/*
 * This file is part of Bluhell Firewall Browser Extension,
 * Copyright (c) 2016, Diego Casorran. All rights reserved.
 *
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/.
 */

(function(global) {
'use strict';

let DOMAINS = [
    // Privacy (07 Aug 2016 19:42 UTC)
    /(?:^|\.)(?:0(?:stats|tracker)|1(?:03bees|1nux|2(?:3co(?:mpteur|unt)|mnkys)|-cl0ud|freecounter|pel)|2(?:0(?:0summit|6solutions)|1sme|4(?:7ilabs|counter|log))|3(?:3across|60(?:tag|i)|d(?:live)?stats)|4(?:0nuggets|oney)|5(?:1(?:network|yes)|5labs)|7(?:7tracking|bpeople)|99(?:c(?:lick|ounters)|stats)|a(?:013|-counters|\.mobify|a(?:ddzz|msitecertifier|n\.amazon)|bc(?:ompteur|stats)|c(?:c(?:essintel|umulatorg)|e(?:counter|trk|xedge)|s86|t(?:i(?:onallocator|ve(?:-trk7|conversion|meter|prospects|tracker\.activehotels))|nx)|xiom-online)|d(?:-score|blade|chem(?:ix|y-content|y)|d(?:freestats|lvr)|e(?:lixir|mails)|greed|insight|ku|mantx|o(?:betag|ftheyear)|rta|s(?:e(?:nsedetective|ttings)|psp|ymptotic)|t(?:hletic|raction)|ultblogtoplist|v(?:anced-web-analytics|conversion)|yapper)|ffi(?:liates-pro|n(?:esystems|itymatrix)|stats)|g(?:entinteractive|kn)|i(?:mediagroup|rpr)|k(?:anoo|stat)|l(?:e(?:nty|xa(?:cdn|metrics))|kemics|ltracked|ta(?:bold1|stat)|venda|zexa)|m(?:a(?:desa|valet|zingcounters)|bercrow|ikay|xdt)|n(?:a(?:l(?:oganalytics|yt(?:ics(?:-egain|wizard)|k))|metrix|tid3)|d(?:roid\.mobile\.linksynergy|yhoppe)|exia-it|g(?:elfishstats|srvr)|onymousdmp|tvoice)|p(?:ex(?:stats|two)|ollofind|pboycdn)|qtracker|r(?:c(?:adeweb|h-nicto)|kayne|lime|p(?:uonline|xs)|turtrack)|s(?:soctrac|tro-way)|t(?:atus|oshonetwork|raxio|t(?:icwicket|racta))|u(?:d(?:ience(?:\.visiblemeasures|amplify|iq|rate)|rte|sp|td)|t(?:horinsights|o(?:-ping|a(?:ffiliatenetwork|udience)|id)))|v(?:a(?:ntlink|stats)|enseo|mws)|w(?:asete|esomelytics|in1)|z(?:alead|era-s014))|b(?:1img|2c|a(?:ifendian|m-x|ptisttop1000|sicstat)|e(?:a(?:con(?:2\.indieclicktv|\.kmi-us)|nst(?:alkdata|ock))|bj|e(?:mrdwn|ncounter)|havioralengine|lstat|nchit|rg-6-82|sucherzahlen|target)|foleyinteractive|i(?:g(?:cattracks|tracker)|onicclick|z(?:ible|o))|k(?:rtx|vtrack)|l(?:izzardcheck|o(?:ckmetrics|g(?:104|-stat|counter|meetsbrand|patrol|r(?:ankers|eaderproject)|s(?:counter|ontop)|toplist))|ue(?:cava|kai)|vdstatus)|m(?:23|324|lmedia|metrix)|o(?:omtrain|ts(?:canner|visit)|unce(?:exchange|x))|r(?:cdn|i(?:dgevine|ghtedge|lig)|onto|srvr)|stn-14-ma|t(?:buckets|static|t(?:rack|tag))|u(?:bblestat|g(?:herd|snag)|mlam|rstbeacon|siness\.sharedcount|x1le001)|ytemgdd)|c(?:1exchange|3(?:metrics|tag)|-o-u-n-t|\.adroll|a(?:dreon|l(?:l(?:ingjustified|measurement|rail|track(?:ingmetric)?s)|otag)|mpaigncog|n(?:alstat|ddi|opylabs)|p(?:hyon-analytics|turly)|s(?:h(?:burners|count)|ualstat))|e(?:dexis|lebros-analytics|ntraltag|rtifica|trk)|ftrack|h(?:a(?:nnelintelligence|rt(?:aca|beat))|eezburger-analytics|r(?:ist(?:iantop1000|malicious)|umedia))|ircular-counters|l(?:ari(?:fyingquack|ty(?:ray|tag))|e(?:a(?:nanalytic|rviewstat)s|v(?:eritics|i))|i(?:ck(?:2meter|-(?:linking|url)|a(?:id|lyz)er|d(?:ensity|imensions)|ening|forensics|inc|m(?:anage|eter)|pathmedia|report|s(?:agen|hif)t|t(?:hru\.lefbc|rack[1s])|zs)|ent\.tahono|x(?:count|py))|oud(?:-exploration|tracer101)|u(?:bcollector|strmaps))|m(?:core|meglobal|ptch)|n(?:etcontentsolutions|xweb|zz)|o(?:gnitivematch|ll(?:arity|serve)|m(?:mander1|p(?:any-target|teur(?:-(?:fr|visite))?)|radepony)|n(?:firm(?:ational|it)|t(?:a(?:ctmonkey|dor(?:gratis|visitasgratis|web)|toreaccessi)|e(?:ntinsights|xtly)|inue|rol\.cityofcairns)|ver(?:getrack|sion(?:ly|ruler)|t(?:experiments|global|ro)))|oladata|pperegg|r(?:e(?:-cen-54|m(?:etric|otive)s)|mce)|st1action|unt(?:by|er(?:-gratis|bot|central|geo|land|s(?:4u|ervis|forlife)|tracker)|his|ing4free|omat|z))|pcmanager|q(?:counter|uotient)|r(?:\.loszona|a(?:ftkeys|zyegg)|iteo|mmetrixwris|o(?:sswalkmail|wd(?:s(?:cience|kout)|twist))|sspxl)|s(?:bew|data1|i-tracking|s\.aliyun)|t(?:\.(?:itbusinessedge|thegear-box)|nsnet|s(?:-(?:log|secure)\.channelintelligenc|\.(?:businesswir|channelintelligenc))e|tracking02)|u(?:ntador|ralate|stomer(?:conversio|discoverytrack))|xense|y(?:bermonitor|toclause))|d(?:-stats|a(?:counter|ilycaller-alerts|pxl|t(?:a(?:\.(?:beyond|imakenews|marketgid)|brain|caciques|feedfile|performa|m)|vantage)|yl(?:ife-analytic|og)s)|c(?:-storm|\.tremormedia)|e(?:17a|cideinteractive|epattention|javu\.mlapps|mand(?:base|media\.s3\.amazonaws)|vice9)|gmsearchlab|i(?:alogtech|d-?it|e-rankliste|ffusion-tracker|git(?:al(?:-metric|optout)|s)|mestore|nkstat|rectrdr|s(?:cover-path|playmarketplace|tr(?:alytics|ibeo))|volution)|jers|lrowehtfodne|m(?:analytics1|d53|pxs|tr(?:acker|y))|o(?:clix|modomain|tomi|ubleverify)|ps-reach|s(?:mmadvantage|p(?:\.linksynergy|arking|ly))|t(?:c-v6t|i-ranker|scout)|u(?:mmy-domain-do-not-change|rocount)|win[12]|yntrk)|e(?:-(?:kaiseki|referrer|zeeinternet)|\.funnymel|a(?:rnitup|sy(?:-hit-counters|counter|hitcounters))|btrk1|c(?:-track|n5|ommstats(?:\.s3\.amazonaws)?|ustomeropinions)|d(?:ge\.bredg|igitalsurvey|w\.insideline)|kmpinpoint|l(?:a(?:-3-tn|sticbeanstal)k|ectusdigital|it(?:e-s001|ics)|oqua)|m(?:a(?:il(?:-(?:match|reflex)|retargeting)|rbox)|beddedanalytics|ediatrack|jcd|ltrk)|n(?:ecto(?:analytics)?|g(?:ageya|ine(?:212|64))|hance|quisite|sighten|t(?:er-system|icelabs))|p(?:erfectdata|i(?:lot|odata|track)|roof)|reportz|s(?:earchvision|omniture|ta(?:disticasgratis|ra|t))|t(?:ahub|h(?:erealhakai|nio)|r(?:acker|igue)|yper)|u(?:-survey|ro(?:counter|pagerank))|v(?:anetpro|e(?:nt(?:\.loyalty\.bigdoor|tracker\.videostrip)|rgage)|isit(?:analyst|cs2?)|olvemediametrics)|web(?:analytics|counter)|x(?:actag|clusiveclicks|elator|it(?:intel|monitor)|ovueplatform|p(?:lore-123|osebox)|t(?:ole|reme-dm))|yein|zytrack)|f(?:a(?:bricww|ctortg|llingfalcon|nplayr|rmer\.wego|st(?:analytic|ly-analytics|onlineusers|webcounter)|thomseo)|bgdc|e(?:ed(?:ji|perfec)t|tchback)|i(?:ksu|litrac|n(?:alid|derlocator)|shhoo|xcounter)|l(?:a(?:gcounter|sh(?:-(?:counter|stat)|adengine|gamestats))|counter|ix(?:360|car|facts)|u(?:ctuo|encymedia|idsurveys|rry)|x(?:pxl|1)|yingpt)|o(?:llowercounter|otprintlive|r(?:e(?:nsics1000|seeresults)|kcdn|m(?:alyzer|isimo)|ter)|undry42)|prnt|qtag|r(?:e(?:e(?:-(?:counter|website-(?:hit-counter|statistic)s)|bloghitcounter|counter(?:code|stat)|logs|onlineusers|s(?:itemapgenerator|tats)|usersonline|weblogger)|s(?:coerspica|h(?:counter|plum)))|iendbuy|osmo|uitflan)|shka|tbpro|u(?:eldeck|getech|n(?:-hits|neld|stage)|se(?:-data|stats))|yreball)|g(?:botvisit|e(?:istm|mtrackers|o(?:bytes|co(?:mpteur|ntatore)|riot)|t(?:backstory|clicky|freeb(?:acklinks|l)|response|smartcontent))|igcount|l(?:anceguide|btracker|ob(?:ase|etrackr))|o(?:-stats\.dlinkddns|\.toutapp|dhat|ingup|ldstats|neviral|ogleadservices|pjn|s(?:quared|tats)|urmetads|vmetric|yavelab)|r(?:a(?:ph(?:effect|insider)|vity4?)|idsum|oundspeak)|secondscreen|t(?:cslt-di2|opstats)|u-pix\.appspot|visit)|h(?:4k5|a(?:l(?:ldata|stats)|veamint|ymarket)|e(?:a(?:ls\.msgfocu|panalytic)s|llosherpa|ntaicounter|tchi|ystaks)|i(?:conversion|gh(?:erengine|metrics)|perstat|stats|t(?:2map|-(?:count(?:er-download|s)|parade)|box|counters(?:online|tats)|farm|matic|s(?:2u|l(?:ink|og)|niffer|processor)|t(?:ail|racker)|w(?:ake|ebcounter)))|lserve|m\.baidu|o(?:mechader|st-tracker|t(?:-count|jar))|qhrt|u(?:b(?:rus|spot)|manclick|n(?:kal|t-leads)|rra)|wpub|xtrack|y(?:fntrak|pe(?:ractivate|stat)))|i(?:-stats|b(?:-ibi|illboard|pxl)|c(?:-live|live|s0)|d(?:fa\.mobile\.linksynergy|targeting)|esnare|factz|ivt|l(?:jmp|lumenix|ogbox)|m(?:a(?:gedoll|nginatium)|manalytics|p(?:\.(?:affiliator|c(?:lickability|onstantcontact))|counter)|rtrack)|n(?:audium|boxtag|d(?:ex(?:stat|tool)s|icia)|eedhits|f(?:erclick|inigraph|lectionpointmedia)|novateads|p(?:honic|ref(?:\.s3\.amazonaws)?|wrd)|s(?:i(?:de-graph|g(?:ht(?:\.mintel|era|grit)|it)|temetrics)|pectlet)|t(?:e(?:l(?:evance|imet|li(?:-(?:direct|tracker)|ad-tracking|gencefocus))|r(?:ceptum|estably|gient|mundomedia|vigil))|rastats)|v(?:itemedia|odo))|os\.mobile\.linksynergy|p(?:2(?:location|map|phrase)|-a(?:dress|pi)|addresslabs|catch|erceptions|f(?:ingerprint|rom)|infodb|locationtools|ro|stat)|qfp1|rs09|st(?:-t)?rack|t(?:alianadirectory|rackerpro)|w(?:ebtrack|stats)|xiaa|zea(?:ranks)?)|j(?:anrain|doqocy|i(?:ankongbao|mdo-stats|rafe)|otform|s(?:counter|onip|tracker)|u(?:mptime|stuno)|wmstats)|k(?:am(?:eleoon|pyle)|ey(?:ade|word(?:-match|max)|xel)|i(?:eden|ss(?:metrics|testing))|l(?:ert|ldabck)|o(?:mtrack|psil|stenlose-counter)|qzyfj|syrium0014)|l(?:2\.visiblemeasures|\.fairblocker|a(?:ndingpg|serstat)|ct\.salesforce|e(?:ad(?:-(?:123|converter)|for(?:ce1|ensics|mix)|i(?:um|d)|life|managerfx|sius|zu)|g(?:enhit|olas-media)|ntainform|s-experts|tterboxtrail|vexis|xity)|i(?:adm|bstat|jit|n(?:ezing|k(?:-smart|\.huffingtonpost|connector|pulse|xchanger))|vestat)|loogg|o(?:calytics|g(?:\.kukuplay|aholic|counter|dy|entries|gly|ua)|o(?:kery|p11)|pley|sstrack)|p(?:beta|orirxe)|sfinteractive|u(?:c(?:idel|kyorange)|minate)|xtrack|y(?:pn|tiks))|m(?:1ll1c4n0|-pathy|\.addthisedge|a(?:baya|g(?:iq|nify360)|p(?:loco|myuser)|r(?:insm|ket(?:015|2lead|izator)|tianstats)|ster(?:stats|tag\.effiliation)|th(?:eranalytics|tag)|xymiser)|b(?:4a|-srv|otvisit|ww)|dotlabs|e(?:asurem(?:ap|entapi)|di(?:a(?:armor|bong|forgews|gauge|plex|seeding|v)|ego)|ga-stats|latstat|mecounter|rc(?:adoclics|ent)|t(?:a(?:keyproduc|lyz)er|e(?:orsolutions|ring\.pagesuite)|ri(?:csdirect|go))|zzobit)|i(?:albj6|codigo|das-i|llioncounter|xpanel)|kt(?:3261|941|oresp)|l(?:314|click|etracker|no6|stat)|m(?:i-agency|stat|tro)|o(?:bify|chibot|n(?:goosemetric|iti)s|trixi|use(?:3k|flow|stats|trace)|vable-ink-6710)|plxtms|sg(?:app|tag)|t(?:racking|s\.mansion)|ucocutaneousmyrmecophaga|v(?:ilivestats|tracker)|xpnl|y(?:affiliateprogram|bloglog|fastcounter|n(?:ewcounter|telligence)|omnistar|r(?:eferer|oitracking)|s(?:coop-tracking\.googlecode|eostats|ocialpixel)|tictac|usersonline))|n(?:a(?:ayna|look|t(?:pal|uraltracking)|v(?:dmp|egg|ilytics)|ytev)|e(?:atstats|dstat|on-lab|stedmedia|t(?:-filter|applications|clickstats|m(?:ini)?ng|ratings)|w(?:relic|scurve|trackmedia)|x(?:eps|tstat))|ga(?:cm|static)|i(?:cewii|ftymaps|nestats)|o(?:nxt1\.c\.youtube|owho|rdicresearch|winteract)|prove|stracking|u(?:conom|datasecurit)y|y(?:ctrl32|tlog))|o(?:adz|bserverapp|ctopart-analytics|d(?:\.visiblemeasures|esaconflate|oscope)|ffer(?:matica|s(?:\.keynote|trategy))|hmystats|idah|ktopost|m(?:arsys|e(?:tri|d)a|g(?:pm|uk)|iki)|n(?:e(?:link-translations|stat|tag-sys)|gsono|line-media-stats)|p(?:bandit|en(?:click|hit|venue|xtracker)|roi|t(?:i(?:m(?:ahub|izely(?:\.appspot)?|ost)|n-machine)|orb))|r(?:anges88|capia|g-dot-com|ts\.wixawin)|s(?:-data|itracker)|t(?:oshiana|racking)|urnet-analytics|verstat|wldata|xidy)|p(?:0\.raasnet|-td|\.raasnet|a(?:-oa|ge(?:fair|rankfree)|idstats|r(?:dot|klogic|rable|sely)|ss-1234|thful)|c(?:licks|speedup)|e(?:erius|r(?:centmobile|f(?:drive|ectaudience|iliate|orm(?:ancerevenues|tracking))|ion|mutive|r\.h-cdn|s(?:ianstat|onyze))|tametrics)|f\.aclst|h(?:on(?:e-an)?alytics|pstat)|i(?:-stats|ano-media|ckzor|kzor|ng(?:-fast|agenow|il|omatic)|x(?:\.speedbit|analytics|el(?:\.(?:parsely|xmladfeed)|eze|interactivemedia|revenue|s(?:\.youknowbes|nippe)t)|imedia))|j(?:atr|tra)|l(?:a(?:cemypixel|tform(?:municatorcorp|panda))|e(?:cki|isty|xop))|m14|ntr(?:ac|[as])|o(?:intomatic|larmobile|psample|r(?:ngraph|tfold)|st(?:affiliatepro|clickmarketing)|wercount)|r(?:-chart|e(?:cisioncounter|dictivedna)|o(?:clivitysystems|ductsup|ext|file(?:rtracking3|snitch)|j(?:ect(?:haile|sunblock)|op\.dnsalias)|motionengine|ofpositivemedia|specteye|v(?:enpixel|idence\.voxmedia))|tracker)|s(?:tat|yma-statistic)s|t(?:engine|o-slb-09|p123|rk-wn)|u(?:bli(?:cidees|sh(?:\.pizzazzemail|flow))|l(?:leymarketing|se(?:log|maps))|re(?:airhits|video)|tags))|q(?:-counter|bop|dtracking|oijertneio|sstats|u(?:altrics|bitproducts|est(?:ionpro|radeaffiliates)|i(?:llion|ntelligence))|zlog)|r(?:24-tech|a(?:\.linksynergy|d(?:ar(?:stats|url)|iomanlibya)|mpmetrics|nk(?:-(?:hits|power)|in(?:gpartner|teractive))|pidcounter|venjs)|d\.linksynergy|e(?:a(?:c(?:h(?:force|socket)|tful)|d(?:ertracking|notify)|l(?:counters|t(?:imeplease|racker)))|coset|d(?:i(?:r\.widdit|stats)|statcounter)|edge|f(?:er(?:forex|lytics|sion)|inedads)|l(?:ead|iablecounter|maxtop)|marketstats|p(?:0pkgr|orting\.reactlite)|s(?:-x|ea(?:rch(?:-(?:artisan|tool)|intel)|u-pub)|on8|ponsetap)|targetly|v(?:enue(?:pilot|science)|olvermaps)|wardtv|ztrack)|fihub|hinoseo|i(?:astats|ch(?:ard-group|metrics|relevance)|ghtstats|tecounter)|k(?:dms|tu)|lcdn|mtag|n(?:engage|g-snp-003|labs)|o(?:i(?:-pro|s(?:ervice|py)|testing|vista)|llingcounters)|rimpl|svpgenius|t(?:bauction|rk)|u(?:manalytics|4)|ztrkr)|s(?:a(?:dv\.dadapro|getrc|jari|mbaads|pha|revtop|s15k01|yyac)|bdtds|c(?:a(?:ledb|rabresearch|stnet)|hoolyeargo|iencerevenue|o(?:recardresearch|ut\.haymarketmedia)|rip(?:pscontroller|t(?:il|s(?:21|head))))|ddan|e(?:a(?:-nov-1|rch(?:feed|ignite|plow))|cure(?:-pixel|\.ifbyphone|paths)|dotracker|e(?:dtag|hits|why)|gment(?:-analytics|ify)?|l(?:aris|ipuquoe|lpoints)|m(?:a(?:nticverses|text)|iocast)|pyra|r(?:ious-partner|v[eu]stat)s|ssioncam|x(?:counter|ystat))|f14g|h(?:ar(?:e(?:asale|dcount)|pspring)|i(?:nystat|ppinginsights)|owroomlogic|rinktheweb)|i(?:ftscience|g(?:\.gamerdna|nup-way)|lverpop|mpl(?:e(?:hitcounter|reach)|ymeasured)|nglefeed|te(?:24x7rum|apps|bro|compass|improve(?:analytics)?|linktrack|meter|stat|t(?:istik|racker)))|k(?:imresources|yglue)|l(?:-ct5|ingpic)|m(?:a(?:llseotools|rt(?:-digital-solutions|zonessva))|fsvc|rtlnks)|n(?:aps\.vidiemi|iphub|o(?:obi|wsignal))|o(?:c(?:ia(?:lprofitmachine|plus)|ketanalytics)|doit|krati|metrics|phus3)|p(?:e(?:cialstat|ed-trap)|ider-mich|klw|l(?:ittag|urgi|yt)|n-twr-14|o(?:nsored|tmx)|ring(?:metrics|serve)|tag[123]?|y(?:log|words))|quidanalytics|rvtrck|t(?:at(?:count(?:er(?:free)?)?|h(?:at|ound)|i(?:c\.parsely|st(?:i(?:c(?:he-(?:free|web)|s\.m0lxcdn\.kukuplay)|q)|x))|owl|s(?:4(?:all|you)|adv\.dadapro|event|forever|i(?:mg|nsight|t)|machine|rely|sheet|wave|w)|t(?:ooz|rax)|u(?:ncore|scake|n))|c(?:llctrs|ounter)|e(?:elhousemedia|llaservice)|ippleit|orm(?:containertag|iq))|u(?:b(?:2tech|traxion)|m(?:mitemarketinganalytics|ome)|ndaysky|per(?:counter|stat)s|r(?:f(?:counters|ertracker)|v(?:ey(?:scout|w(?:all-api\.survata|riter))|icate)))|v(?:r-prc-01|trd)|w(?:fstats|iss-counter|oopgrid)|xtracking|y(?:nergy-(?:sync|e)|somos))|t(?:-analytics|\.(?:d(?:evnet|gm-au)|powerreviews)|a(?:g(?:4arm|c(?:dn|ommander)|ifydiageo|srvcs|tray)|iltarget|nx|p(?:filiate|stream)|rgetfuel)|cimg|d(?:573|stats)|e(?:aliumiq|l(?:ize|laparts?)|ndatta|rabytemedia|t(?:igi|oolbox))|he(?:adex|b(?:estlinks|righttag)|counter|freehitcounter|rmstats|specialsearch)|i(?:nycounter|soomi-services|tag)|kqlhce|l813|m(?:1-001|pjmp|vtp)|o(?:p(?:100(?:blogger|webshop)s|-bloggers|blog(?:area|ging)|depo|malaysia|ofblogs|s(?:em|tat))|r(?:bit|o-tags)|uchclarity)|r(?:a(?:ce(?:-2000|\.qq|lytics|works)|dedoubler|f(?:fikcntr|it)|il(?:-web|headapp)|k(?:ksocial\.googlecode|zor))|bo|e(?:asuredata|ehousei|ndcounter)|igg(?:er(?:edmessaging|tag\.gorillanation)|it)|k(?:\.pswec|jmp|lnks)|y\.abtasty)|s(?:c(?:apeplay|ounter)|k[45]|w0)|twbs\.channelintelligence|urn|wcount|y(?:nt|xo))|u(?:5e|a(?:dx|rating)|bertags|gdturner|mbel|ni(?:caondemand|versaltrackingcontainer)|p(?:-rank|t(?:imeviewer|olike|racs))|r(?:iuridfg|l(?:brie|sel)f)|s(?:abil(?:itytools|la)|er(?:cycle|d(?:ive|mp)|look|onlinecounter|report|zoom)|uarios-online)|zrating)|v(?:a(?:laffiliates|maker)|banalytics|d(?:na-assets|oing)|e(?:duy|interactive|laro|ntivmedia|r(?:t(?:icals(?:cope|earchworks)|ster)|ypopularwebsite))|i(?:deostat|glink|n(?:lens|ub)|r(?:alninjas|ool)|s(?:i(?:b(?:ility-stats|l(?:emeasures|i))|oncriticalpanels|stat|t(?:or(?:-track|globe|inspector|js|p(?:ath|rofiler)|tracklog|ville)|streamer))|ual(?:dna(?:-stats)?|revenue|websiteoptimizer))|v(?:istats|ocha)|zu(?:ry)?)|m(?:m(?:-satellite[12]|pxl)|trk)|o(?:icefive|odooalerts|tistics)|unetotbe)|w(?:3counter|atch\.teroti|e(?:b(?:-(?:stat|visor)|c(?:are\.byside|ompteur)|engage|flowmetrics|g(?:ains|lstats|ozar)|iqonline|leads-tracker|masterplan|s(?:erviceaward|ite(?:-hit-counters|ceo|onlinecounter|perform|sampling|welcome)|pectator|tats4u)|t(?:r(?:a(?:ffiq|xs)|ends)|una))|count4u)|h(?:ackedmedia|i(?:sbi|tepixel)|o(?:aremyfriends|isvisiting|s(?:clickingwho|eesyou|on)))|i(?:ki(?:a-beacon|odeliv)|shloop)|o(?:opra-ns|rld(?:gravity|logger))|p(?:-stats|dstat)|r(?:ating|edint)|statslive|t(?:-safetag|p101|stats)|undercounter|ww-path|y(?:sistat|wy(?:userservice)?)|zrkt)|x(?:-traceur|\.ligatus|a-counter|clk-integracion|g4ken|hit|iti|l-counti|tremline|xxcounter)|y(?:-track|a(?:manoha|udience)|botvisit|ellowbrix|gsm|i(?:eld(?:bot|ify|software)|gao)|ouramigo)|z(?:anox|dtag|e(?:bestof|nlivestats|sep)|irve100|o(?:ntera|om(?:flow|ino)|wary)|roitracker|t(?:-dst|cadx)))\.com$/,
    /(?:^|\.)(?:2(?:cnt|o7)|3(?:60tag|gl)|7eer|8020solutions|a(?:8ww|-pagerank|bmr|c(?:estats|int)|d(?:c(?:-serv|l(?:ear|ickstats))|dcontrol|track\.calls)|gencytradingdesk|mctp|n(?:a(?:ly(?:sistools|tics-engine)|metrix)|rdoezrs)|picit|udienceinsights|vazu(?:dsp|tracking)|xf8|8)|b(?:a(?:rillianc|ynot)e|btrack|etarget|i(?:dswitch|g(?:mir|stats)|zspring)|log(?:ranking|tw))|c(?:4tw|edexis|h(?:artbeat|eckmypr)|ityua|lick(?:able|c(?:lick|onversion)|tale)|mcintra|n(?:t1|zz)|o(?:gmatch|n(?:tentspread|ver(?:sionlogic|tmarketing))|pacast|unter(?:-kostenlos|city|views))|r(?:iteo|osspixel|wdcntrl)|ya(?:1t|2))|d(?:1447tq2m68ekg\.cloudfront|21o24qxwf7uku\.cloudfront|3a2okcloueqyx\.cloudfront|9lq0o81skkdj\.cloudfront|e(?:c(?:dna|ibelinsight)|lidatax|mdex|qwas)|i(?:gidip|scovertrail)|o(?:minocounter|tmetrics)|pbolvw|u8783wkf05yr\.cloudfront)|e(?:-(?:pageran|webtrac)k|clampsialemontree|d(?:geadx|t02)|ffectivemeasure|msecure|resmas|s(?:m1|track)|u(?:lerian(?:cdn)?|ropuls)|v(?:erest(?:js|tech)|yy)|yeota|zakus)|f(?:eedcat|l(?:ixsyndication|owstats)|re(?:e(?:-counters|geoip|stats)|maks)|uziontech)|g(?:\.delivery|e(?:oplugi|tconversio)n|o-mpulse|rmtech|simedia|tags|u(?:anoo|ruquicks))|h(?:it(?:maze)?-counters|s-analytics|urterkranach)|i(?:bpxl|hstats\.cloudapp|m(?:cht|rk)|n(?:centivesnetwork|dividuad|finity-tracking|stadia|voca)|p(?:-label|count(?:er)?)|yi)|jump-time|k(?:eymetric|it(?:bit|code)|nowledgevine|ontagent|rxd)|l(?:fov|ivehit|o(?:gnormal|opfuse)|ypn)|m(?:a(?:gnetmail1|rketo|x(?:track|ymis)er)|e(?:dia(?:bong|partner\.bigpoint)|etrics|gastat)|kt51|m7|o(?:balyzer|n(?:etate|itus))|pwe|stracker|wstats|x(?:cdn|ptint)|y(?:pagerank|stat-in|visualiq))|n(?:e(?:dstat(?:basic|pro)?|t(?:biscuits|graviton))|gmco|pario-inc|r-data|s1p|uggad)|o(?:fferpoint|jrq|mtrdc|nline-(?:metrix|right-now)|p(?:en(?:stat|tracker)|tify)|spserver|wneriq)|p(?:\.delivery|ages05|ingdom|lwosvr|m0|pctracking|r(?:edict(?:iveresponse|a)|imetag|nx|oxad))|q(?:baka|uick-counter)|r(?:7ls|apid(?:stats|trk)|e(?:altimestatistics|dcounter|edbusiness|invigorate|search|v(?:dn|enuewire|sw))|oi(?:-rocket|tracking)|s6|tfn)|s(?:3s-main|a(?:geanalyst|yyac)|coutanalytics|e(?:arch\.mediatarget|masio|nsic|o(?:-master|parts))|itebro|m(?:art(?:-ip|erremarketer|racker)|ileyhost)|o(?:cialtrack|ftonic-analytics)|p(?:acehits|eedcounter|ring-tns|ycounter)|rpx|tat(?:is(?:fy|ti(?:chegratis|k-gallup))|s(?:advance-01|y))|ubmitnet|vlu|ynthasite)|t(?:\.ymlp275|argetix|cactivity|e(?:lemetrytaxonomy|ntaculos)|hes(?:earchagency|tat)|ns-cs|overy|r(?:a(?:c(?:etracking|k-web)|f(?:ex|iz))|ekmedia|kme|uehits)|ylere)|u(?:apoisk|rl-stats)|v(?:3cdn|antage-media|ertical-leap|i(?:afoura|sitlog|zisense)|tracker)|w(?:55c|aplog|eb(?:-(?:boosting|counter|stat)|tr(?:affstats|ekk(?:-(?:asia|us))?))|ho(?:aremyfriends|isonline)|isetrack|t-eu02|underloop)|x(?:cl(?:aimword|ick)s|panama)|yoochoose|z(?:ampda|dbb|iyu|oosnet|qtk))\.net$/,
    // Advertisement (07 Aug 2016 20:00 UTC)
    /(?:^|\.)(?:0(?:07-gateway|icep80f|llii0g6|xwxmj21r75kka)|1(?:0(?:0pour|1m3|3092804|pipsaffiliates|y5gehv)|100i|2(?:3(?:cursors|vidz)|place)|5(?:2media|yomodels)|8(?:00freecams|8server|clicks|naked)|c(?:cbt|lickdownloads)|empiredirect|loop|nimo|phads|tizer|worldonline|yk851od)|2(?:0(?:6ads|dollars2surf)|1sexturycash|4(?:7realmedia|x7adservice)|54a|dpt|kurl|leep|xbpub)|3(?:2b4oilo|393|50media|6(?:0(?:ads(?:track)?|installer|popads|yield)|5sbaffiliates)|7signals|cnce854|l(?:ift|r67y45)|omb|r(?:dads|edlightfix)|t7euflv)|4(?:0xbfzk8|3plc|5i73jv6|dsply|uvjosuc|wnet)|5(?:9zs1xei|advertise|clickcashsoftware|dimes|gl1x9qc)|6(?:00z|99fy4ne)|7(?:50industries|7(?:7(?:-partners?|partners?|seo)|8669)|cxcrejm|insight|pud|search|u8a8i88|vws1j1j)|8(?:3nsdjqqo1cau183xz|88(?:games|medianetwork|p(?:oker|romos))|ipztcc1)|9(?:7d73lsi|ts3tpia)|a(?:2pub|3pub|4(?:33|dtrk)|5pub|-s(?:sl\.ligatus|tatic)|\.(?:adroll|ligatus|raasnet|sucksex)|a\.voice2page|b(?:4tn|\.adultcamfree|geobalancer|letomeet|outads\.quantcast|s(?:ilf|oluteclickscom|quint)|usedbabysitters)|c(?:c(?:e(?:lacomm|ss-mc)|ltr|mgr|ounts\.pkr|u(?:mulatork|serveadsystem))|mexxx|ronym|ti(?:on(?:desk|locker)|vedancer))|d(?:1(?:2[01235789]|3[124])m|2(?:games|up)|4(?:game|partners)|-(?:411|bay|clicks|f(?:eeds|low)|gbn|indicator|maven|s(?:ponso|ti)r|u)|a(?:c(?:ado|ts)|gora|pd)|b(?:\.fling|m[ai]|oost|r(?:au|ite|ook?)|u(?:ddiz|ll|tler|yer))|c(?:a(?:de|sh)|d(?:nx|e)|entriconline|h(?:ap|emical)|lick(?:africa|media|service)|mps|o(?:lo(?:ny)?|n(?:jure|scious))|r(?:ax|on|u))|d(?:aim|bags|elive|i(?:nto|ply)|now|o(?:-mnton|er)|roid|t(?:his|oany)|ynamix)|e(?:cn|dy|lement|ngage|spresso|x(?:cite|prts?|tent))|f(?:a(?:ctory88|rm\.mediaplex)|click1|eedstrk|o(?:otprints|rg(?:ames|einc))|r(?:amesrc|ika|ontiers)|u(?:nkyserver|sion|x))|g(?:a(?:lax|rdener|temedia)|e(?:ar|nt007)|i(?:la|tize)|o(?:rithms|to|i)|r(?:oups|x))|h(?:ese|itzads|o(?:od|stingsolutions))|i(?:cate|kteev|m(?:ise|mix|p(?:act|eria|s))|n(?:c(?:on|h)|digo|te(?:nd|rax))|q(?:global|uity)|reland|s(?:fy|n)|t(?:-media|ion|or))|j(?:al|ector|ourne|u(?:ggler|n(?:gle|ky)|g))|k(?:lip|nowledge|o(?:nekt|va)|2)|l(?:andpro|egend|isher|o(?:aded|oxtracking)|partner|ux)|m(?:a(?:iltiser|mba|n(?:age|media)|xim)|e(?:do|ld|ta|z)|itad|ngronline|ob|pads|tpmp127|ulti|zn)|n(?:anny|e(?:ctar|mo|t(?:work(?:performanc|m)|xchang)e|t)|gin|i(?:gma|mation|um)|o(?:ble|w)|xs1?)|o(?:bedtm|hana|n(?:ion|ly|news)|p(?:erator|tim)|rika|t(?:ic|omy|ube)|vida)|p(?:a(?:cks|rlor|y)|er(?:fect|iu[mn])|hreak|inion|l(?:ugg|xmd)|oper|pv|r(?:e(?:dictive|mo)|o(?:fit2share|tected|n))|ushup)|qu(?:antix|est3d)|r(?:cdn|e(?:a(?:ctor|dy(?:tractions)?)|sellers|volver)|ocket|unnr)|s(?:2srv|4cheap|-(?:4u|stats|twitter)|a(?:feprotected|lvo|me)|b(?:ookie|rook)|c(?:endmedia|lickingnetwork)|dk|ensecamp|f(?:ast|orindians|u(?:ndi|se))|gangsta|h(?:ack|exa|o(?:pping|st(?:net|view|[12]))|uffle)|i(?:duou|gnal|mili|nimage)s|judo|l(?:i(?:dango|ngers)|ot|vr)|m(?:arket|oon)|n(?:ative|etworkserver)|o(?:nar|p(?:timal|x)|vo)|p(?:dbl|eed|ruce|ynet)|r(?:ing|v(?:\.(?:bangbros|eacdn)|media))|t(?:argeting|erra)|u(?:p(?:ermarket|ply(?:ads|ssl)?)|rve)|v(?:cs|ert|ids)|xgm|p)|t(?:aily|dp|e(?:c(?:hus|c)|ractive)|gs|hrive|lgc|o(?:add|l(?:ogy[123]|l)|ma(?:fusion)?|o(?:ls(?:2\.ama|\.gossip)kings|x))|pix|r(?:gt|ix|overt|uism)|wirl)|u(?:acni|lt(?:3dcomics|-adv|a(?:ccessnow|d(?:media|world))|cam(?:chat)?free|force|linkexchange|m(?:ediabuying|o(?:da|viegroup))|popunders|sense|t(?:ds|iz))|rr)|v(?:777|-plus|a(?:n(?:seads|tage(?:globalmarketing|media))|r(?:kads|d))|e(?:ntor[iy]|r(?:igo|keyz|sal(?:display|servers)?))|google|isorded|m(?:ania|edialtd|d)|points|r(?:edir|tice)|uatianf)|w(?:hirl|ires|or(?:dsservicapi|kmedia|ldmedia))|x(?:-t|c(?:hg|ore)|i(?:on|te)|market|p(?:ansion|o(?:se|wer))|regie)|yo(?:ulike|z)|z(?:bazar|hub|iff|m(?:edia|ob)|o[nu]k|power|s))|eesy|f(?:cyhf|dads|f(?:-(?:jp\.(?:dxlive|exshot)|online)|b(?:ot[1378]|uzzads)|i(?:liat(?:e-(?:gate|robot|b)|ion-(?:france|int))|nit(?:ad|y))|p(?:lanet|ortal-lb\.bevomedia)|track|utdmedia)|lrm(?:alpha)?|ricawin|terdownloads?)|g(?:cdn|entcenters|gregat(?:eknowledge|orgetb)|mtrk|omwefq|vzvwof)|halogy|i(?:m(?:4media|atch)|pmedia|rpush)|j(?:gffcat|illionmax)|k(?:1\.imgaft|\.imgaft|amhd)|l(?:chemysocial|fynetwork|go(?:cashmaster|rithmia|vid)|imama|l(?:-about-tech|a(?:bc|dultcash)|eliteads|mt|o(?:sponsor|ydigital)|pass\.salemwebnetwork|s(?:lotscasino|porttv)|yes)|p(?:ha(?:bird(?:network)?|godaddy)|inedrct)|t(?:ernativeadverts|itude-arena))|m(?:-display|a(?:teur\.amarotic|zon(?:-cornerstone|ily))|baab|d2016|ertazy|gdgt|obee|pxchange|tracking01)|n(?:astasia(?:-international|saffiliate)|d(?:ase|omedia(?:group)?)|ge(?:ge|lpastel)|ime\.jlist|nualinternetsurvey|o(?:miely|nymousads)|swered-questions|t(?:araimedia|oball)|wufkjjja|yxp)|o(?:qneyvmaz|r(?:ms|pum))|p(?:i\.(?:140proof|flattr|groupon|oneall|starsmp)|mebf|p(?:ads|endad|lebarq|next|ortium|tap|webview)|r(?:il29-disp-download|omoweb)|smediaagency|xlv)|quete|r(?:\.voicefive|ab4eg|cade(?:be|chain)|e(?:-ter|as(?:ins|nap))|ti-mediagroup)|s(?:5000|-farm|\.devbridge|afesite|eadnet|iafriendfinder|klots|ooda|rety|s(?:etize|oc-amazon)|terpix)|t(?:adserver|emda|malinks|r(?:esadvertising|insic)|wola)|u(?:2m8|ctionnudge|di(?:ence(?:2media|fuel|profiler)|tude)|g(?:renso|ust15download)|nmdhxrco|spipe|to(?:-i(?:nsurance-quotes-compare|m)|linkmaker\.itunes\.apple|mateyourlist))|v(?:al(?:anchers|opaly)|ercarto|gthreatlabs)|w(?:a(?:dhtimes|kebottlestudy)|empire|ltovhc|mpartners|s(?:clic|mer|urveys))|x(?:47mp-xp-21|ill)|yboll|z(?:ads|erbazer|jmp|o(?:ogleads|rbe)|tecash))|b(?:2c-wsinsight\.crowdfactory|\.sell|a(?:b(?:bnrs|es\.picrush)|ck(?:beatmedia|links)|d(?:ge(?:\.(?:clevergirlscollective|facebook)|s\.(?:alltop|instagram)|ville)|jocks)|kkels|mb(?:ergerkennanchitinous|oocast)|n(?:anaflippy|delcot|man\.isoftmarketing)|ordrid|r(?:g(?:ainpricedude|etbook)|onsoffers)|skodenta|tarsur|ungarnr|vesinyourface|ypops)|b(?:elements|p\.brazzers|redir-ac-100|uni)|c(?:\.coupons|ash4you)|e(?:a(?:conad|tchucknorri)s|bi|coquin|dorm|erforthepipl|f(?:ad|orescenc)e|l(?:amicash|ointeractive|write)|n(?:chmarkingstuff|tdownload)|ringmedia|st(?:-zb|casinopartner|f(?:indsite|orexpartners)|gameads|h(?:itsnow|olly)|o(?:fferdirect|nlinecoupons)|pr(?:icewala|oducttesters)|ssn)|t(?:3(?:000partner|65affiliate)s|a(?:\.down2crazy|ffs)|oga|rad|ting(?:\.betfair|partners)|weendigital))|fast|gmtracker|i(?:d(?:gewatr|system|ver(?:drd|tiser))|emedia|g(?:door|fineads)|jscode|llypub|mlocal|n(?:aryoptions(?:24h|game)|go4affiliates|layer)|skerando|t(?:coinadvertiser|tad)s|z(?:ographics|rotator|zclick))|jjingda|l(?:a(?:ck6adv|m(?:ads|city)|rdenso|undorz|zwuatr)|inkadr|o(?:cks\.ginotrack|g(?:c(?:atalog|lans)|engage|ger(?:ex|greetbox\.googlecode)|herads|lines|ohertz|topsites)|ssoms|wwor)|u(?:e(?:advertise|streak|toad)|posr))|manpn|n(?:etworx|html|mla)|o(?:-videos\.s3\.amazonaws|a(?:fernd|rd-books)|gads|inkcash|kroet|n(?:gacams|usfapturbo|zuna)|o(?:-box|k(?:ingdragon|ofsex)|m-boom-vroom|st(?:able|clic|show))|p-bop-bam|roras|stonparadise|ylesportsreklame)|ptracking|r(?:\.rk|a(?:inient|n(?:chr|d(?:-display|clik|reachsys)|zas)|ssyobedientcotangent|venetmedianetwork)|ea(?:dpro|ltime)|i(?:d(?:getrack|lonz|uend)|ght(?:eroption|share))|o(?:adstreetads|keloy|thersincash|wsersfeedback)|qvld0p|ucelead)|strtb|t(?:n(?:\.createsend1|ibbler)|rll|tbgroup)|u(?:520|a(?:ltwif|mingh)|d(?:getedbauer|url)|l(?:etproofserving|garine|letproofserving)|m(?:blecash|pin)|n(?:chofads|ny-net)|oalait|r(?:jam|stnet)|sinessc(?:are|lick)|ttons\.(?:contactme|reddit)|x(?:ept|flow)|y(?:flood|orselltnhomes|sellads)|zz(?:-stats|buttons|paradise))|winpartypartners|y(?:spot|vue)|zrvwbsh5o)|c(?:8factor|-on-text|a(?:llmd5map|m(?:4(?:flat|tracking)|crush|d(?:ough|uty)|p(?:a(?:nja|rtner)|lacecash|rime)|s(?:\.spacash|ense|itecash)|zap)|n(?:aanita|o(?:eklix|nresourcecenter))|p(?:acitygrid|itatmarket|t(?:ainad|ifymedia))|r(?:bonads|s\.fyidriving|to(?:ontube|rkins))|s(?:\.criteo|alemedia|h(?:4m(?:embers|ovie)|-(?:duck|program)|\.femjoy|atgsc|layer|mylinks|onvisit|t(?:hat|raf(?:ic|f)))|i(?:no(?:-zilla|\.betsson)|ours)|pion|t(?:erpretic|platform))|w\.criteo|ygh)|b(?:-content|aazars|c(?:lick(?:bank|s)|omponent)|leads)|c-dt|d(?:828|n(?:-image|\.(?:a(?:dblade|ssets\.gorillanation)|mobicow|o(?:ffclou|ptm)d)|a(?:\.tremormedia|ds)|farm18|jke|rl|servr|trip))|e(?:epq|l(?:ebjihad|ogera)|nnter|r(?:otop|tified-apps))|h(?:a(?:ngo|r(?:geplatform|ltonmedia))|e(?:-ka|ck(?:m8|outfree)|rytso|styry)|i(?:na-netwave|pleader|tika)|o(?:ices\.truste|pstick16)|ronicads|ualangry)|i(?:bleclick|rcularhub|ty(?:adspi|se)x)|l(?:a(?:sh-media|xonmedia|yaim)|dlr|e(?:a(?:fs|r(?:-request|ac)|vageguarantyaquarius)|nte|vv)|i(?:ck(?:2jump|a(?:ble|gy)|b(?:et88|ooth(?:lnk)?)|c(?:ash|ertain)|exa|fuse|ganic|i(?:ntext|ocdn)|mngr|nano|osmedia|s(?:2count|ifter|or|venue)|t(?:hru(?:cash|server)|ripz)|upto|winks|xchange|z(?:\.lonelycheatingwives|xc))|x(?:galore|sense|trac))|kfeed|mbtech|o(?:ckdisplaystoring|ud(?:srvtrk|tracked))|premdo)|m(?:dfnow|fads)|o(?:advertise|de(?:\.popup2m|lnet|zap)|edmediagroup|g(?:sdigital|uan)|in(?:ad|tent)|l(?:dhardcash|l(?:ection-day|iersads)|oredguitar|pory)|m(?:botag|click|eadvertisewithus|m(?:ission(?:-junction|lounge|monster)|unicatoremail)|p(?:le(?:tecarrd|xmedianetwork)|utersoftwarelive)|score|unicazio|wgi)|n(?:duit-services|exitry|n(?:atix|e(?:cti(?:gnite|onads)|x(?:place|tra)))|s(?:ent(?:-st)?\.truste|trument|umergenepool)|t(?:a(?:dd|xe)|e(?:nt(?:-(?:4-u|cooperation)|\.liveuniverse|abc|js|ure)|xt(?:uads|web)))|ver(?:sionsbox|tsocial)|yak)|o(?:kie(?:-script|assistant|bot|consent\.silktide|information|manager1\.contentforces|reports|q)|l(?:erads|mirage))|pacet|r(?:-natty|e\.queerclick|nflip|ruptcy|write)|smjs|tnr|u(?:ll|pon2buy))|p(?:\.intl\.match|a(?:beyond|c(?:lick[sz]|oreg)|grip|l(?:ead|ock)|nuk|way|y(?:ard|s))|cadnet|fclassifieds|layer\.blinkx|m(?:a(?:dvisors|ffiliation)|leader|star|t(?:erra|ree))|u(?:im|laptop)|v(?:ad(?:vertise|s)|tgt)|x(?:24|adroit|interactive))|r(?:a(?:k(?:cash|media)|zy(?:lead|videosempire))|e(?:ative-serving|oads)|ispads|o(?:c(?:oads|spaceoptimizer)|ssrider|wd(?:g(?:atheradnetwork|ravity)|ynews))|tracklink|uiseworldinc)|s\.(?:celebbusters|exposedontape)|t(?:asnet|cautobody|enetwork|m-media|rhub|yzd)|u(?:asparian|bics|elinks|r(?:ancience|iyo|t(?:aecompartilha|isfrierson)))|w(?:gads|trackit)|y(?:b(?:er(?:bidhos|netentertainmen)t|mas)|gnus))|d(?:03x2011|2(?:9gqcij|\.ligatus|ship)|3lens|5zob5vm0r8li6khce5he5|-l-t|\.(?:adroll|ligatus)|a(?:ffaite|llavel|n(?:a123|zabucks)|r(?:edorm|warvid)|s(?:5ku9q|hbida)|t(?:a(?:-eroadvertising|\.adroll|cratic-px|wrkz)|e(?:f(?:ree|unclub)|traders)|ing(?:-adv|a(?:dnetwork|mateurs)|gold|idol)|umreact)|zhantai)|b(?:bsrv|clix|lpmp)|c121677|e(?:al(?:current|s(?:\.macupdate|warm))|cision(?:mark|news)|dicated(?:media|networks)|e(?:cash|pmetrix)|faultimg|guiste|l(?:ivery(?:4[579]|51)|napb)|manier|notyro|p(?:loyad|ositphoto|r(?:avedwhore|esi))s|r(?:iversal|kopd|latas)|s(?:capita|tinationurl)|t(?:ailtoothteam|roposal)|velop(?:-forevery4u|ermedia)|x(?:imedia|platform))|fskgmrepts|gma(?:tix|ustralia|xinteractive)|hundora|i(?:a(?:bolicaf|mondtraff|nomi)|g(?:i(?:pathmedia|t(?:aldesir|revenu)e)|sby)|nclinx|rect(?:aclick|clicksonly|ion-x|leads|nicparking|orym|rev|tr(?:ac)?k)|s(?:creetlocalgirls|pop|qusads|tant(?:news|stat))|v(?:ascam|ertura))|j-updates|l(?:-rm|tag)s|m(?:g-mobile|u20vut)|n(?:bizcdn|tr(?:ax|ck))|o(?:jerena|llar(?:ade|sponsor)|m(?:ain(?:advertising|buyingservices|sponsor)|dex|inoad)|ogleonduty|renga|t(?:andads?|mailer-surveys|net(?:kicks|shoutout))|u(?:ble(?:-check|click(?:bygoogle)?|gear|pimp|r(?:ads|ecall))|mantr)|wn(?:1oads|loa(?:d(?:-performanc|boutiqu|thesefil)e|transfer)|songlyrics))|p(?:msrv|s(?:rexor|tack))|r(?:eamaquarium|nxs|owle)|s(?:n(?:extgen|r-affiliates)|ultra)|t(?:iserv2|mpub|zads)|u(?:amews|delsa|etads|ggiads|r(?:nowar|okuro|tz))|vdkinoteatr|y(?:ino|nami(?:c(?:dn|oxygen|serving)|tedata)))|e(?:9mlrvy1|-(?:generator|viral)|a(?:rnify|sy(?:ad|download(?:4you|now)|flirt|hits4u|inline))|b(?:ayobjects|dr[23]|lastengine|ocornac|uzzing|zkswbs78)|c(?:ortb|pmrocks|to-ecto-uno)|dgevertise|gamingonline|kmas|l(?:e(?:ctnext|fantsearch|kted|pheny)|itsearch)|m(?:berads|ediawebs|p(?:iremoney|tyspaceads))|n(?:gineseeker|lnks|t(?:erads|recard(?:\.s3\.amazonaws)?))|osads|p(?:icgameads|t(?:ord|um))|r(?:endri|goledo|o(?:a(?:dvertising|nalysis)|sadv|tikdating|v(?:ation|inmo))|shgrst)|s(?:c(?:alatenetwork|o(?:kur|rts)o)|pecifican|say(?:ad|coupon)s)|t(?:argetnet|gdta|ology|rader\.kalahari)|u(?:2xml|r(?:ew|o(?:-rx|click|pacas(?:ino|h))))|v(?:e(?:ntful|rnote)|olve(?:mediallc|nation))|webse|x(?:act(?:drive|ly0r)|c(?:ellenceads|hange4media|iliburn|lusivepussy|olobar)|ernala|gfpunished|it(?:explos|junct)ion|lpor|o(?:clickz?|gripper|ticads)|p(?:lorer\.sheknows|o(?:crack|grim|nential))|t(?:onsuan|ra33))|ye(?:medias|re(?:turn)?|viewads|wonder)|zmob)|f(?:-(?:hookups|questionnaire)|a(?:bolele|ce(?:book(?:cover|ofse)x|porn)|ggrim|ir(?:adsnetwork|blocker)|n(?:delcot|sign\.streamray)|pality|r-far-star|st2earn|tads\.toldya)|b(?:-plus|ooksluts|svu)|cgadgets\.blogspot|e(?:at(?:ence|ure(?:dusers|link))|ed(?:\.mikle|age|blitz|s\.delicious)|l(?:ixflow|jack)|m-inc|nixm)|hserve|i(?:gshare|l(?:amentapp(?:-assets)?\.s3\.amazonaws|e(?:loadr|stube|target)|t(?:ermomosearch|hads))|mserve(?:\.myspace)?|nd(?:-abc|andtry|onlinesurveysforcash|sthat)|r(?:axtech|e(?:feeder|g(?:etbook|ob))|m(?:harbor|protected)linked|st(?:-rate|adsolution|class-download|lightera|mediahub))|sari|xionmedia)|l(?:ash(?:adtools|clicks|group|talking)|e(?:sh(?:cash|lightgirls)|xlinks)|irt(?:4(?:fre)?e|ingsms)|o(?:donas|migo)|uxads|ymyads)|m(?:dwbsfxf0|s(?:ads|cash))|nc(?:ash|net1)|o(?:aks|calex|gzyads|llo(?:wistic|yu)|o(?:dieblogroll|nad|t(?:ar|erslideupad|note))|r(?:cepprofile|ex(?:-affiliate|yard)|getstore|ifiha|pyke|restersurveys)|ulsomty)|r(?:ameptp|e(?:akads|e(?:-porn-vidz|biesurveys|couponbiz|onescams|paidsurveyz|rotator|s(?:kreen|oftwarelive)|tellafriend|webcams)|st(?:acero|ime))|hgxd|iendlyduck|omfriendswithlove|ty[abe]|u(?:amens|itkings|trun)|x(?:le|rydv))|tjcfx|u(?:andarst|ck(?:bookdating|ermedia|youcash)|elbuck|gger\.ipage|n(?:klick|nypickuplinesforgirl)s|ture(?:residual|u)s)|w(?:bntw|ix)|x(?:depo|yc0dwa))|g(?:4whisperermedia|6ni40i7|726n8cy|a(?:g(?:acon|enez)|inmoneyfast|l(?:ileofive|leyn)|m(?:bling-affiliation|e(?:-clicks|ads|cetera|hotus|rsad|srevenue|vui24))|n(?:ardineroreal|ja|nett\.gcion)|r(?:risto|vmedia)|t(?:e-ru|ikus)|y(?:ad(?:network|pros)|xperience))|biwxmjw|dmdigital|e(?:f(?:hasi|nar)o|mineering|n(?:e(?:gd|ric(?:link|steps)|sismedia)|i(?:alradio|eessp)|ovesetacet)|o(?:\.(?:camazon|query\.yahoo)|i(?:nventory|pads)|promos|visite)|stionpub|t(?:\.(?:2leep|box24casino|davincisgold|paradise8|rubyroyal|slotocash|thisisvegas)|drip|g(?:lu|scfre)e|iton|m(?:ailcounter|yads)|s(?:co(?:recash|utapp)|ecuredfiles|mily)|traff))|f(?:hdkse|xa\.sheetmusicplus)|g(?:ncpm|wcash)|i(?:antaffiliates|b(?:-gib-la|sonvillainousweatherstrip)|miclub|thubbadge\.appspot)|klmedia|l(?:-cash|btrk|ical|o(?:bal(?:adsales|interactive|successclub)|wdot))|o(?:2euroshop|ember|g(?:oplexer|vo)|joingscnow|ld(?:-file|erotica)|o(?:d(?:-black4u|bookbook|luckblockingthis)|gle(?:adservicepixel|syndicatiion))|r(?:gonkil|oost|tags)|toplaymillion|v(?:er(?:eign|nmenttrainingexchange)|iral-content))|p(?:acalculatorhighschoolfree|lusapi\.appspot)|r(?:a(?:bmyads|fpedia|tisnetwork|zeit)|e(?:at(?:branddeals|cpm)|en(?:-red|labelppc)|nstia|tzalz|ystripe)|idlockparadise|llopa|o(?:ovinads|u(?:chyaccessoryrockefeller|pcommerce))|t0[23]|uadhc)|s(?:csystemwithdarren|niper2)|tsads|u(?:itaralliance|mgum|n(?:partners|zblazingpromo)|rurevenue)|wallet|x101|zbop)|h(?:12-media|a(?:l(?:fpriceozarks|lucius|ogennetwork)|n(?:aprop|dll)|r(?:dcoresexnow|renmedianetwork)|v(?:etohave|inates|nr))|b-247|d(?:-plugin|player-download|vid-?codecs)|e(?:a(?:dup|lth(?:affiliatesnetwork|carestars|grades))|biichigo|llo(?:bar|reverb)|ntaibiz|r(?:avda|ezera|ocpm)|xagram)|g(?:da|hi)t|hourtrk2|i(?:adone|ddenbucks|gh(?:cpm|net)s|jacksystem|mediad[sx]|p(?:als|ersushiads|lair)|stians|t(?:-now|wastedgarden)|zlireklam)|lads|mongcash|n(?:-button\.herokuapp|button\.appspot|like)|o(?:kaybo|me-soon|okupbucks|p(?:feed|ilos)|r(?:ny(?:birds|girlsexposed|matches|spots)|sered|yzon-media)|sti(?:canaffiliate|ng\.conduit)|t(?:-(?:dance|social)s|chatdirect|elscombined|keys|ptp|social[sz]|words)|ustion|wtodoblog)|pr\.outbrain|qfootyad4\.blogspot|s(?:mclick|slx|tpnetwork)|ttpool|u(?:lahooprect|zonico)|yper(?:linksecure|trackeraff|vre|webads))|i(?:2casting|\.skimresources|a(?:mediaserve|sbetaffiliates)|b(?:atom|ryte)|c(?:direct|qadvnew)|d(?:e(?:al(?:-sexe|media)|ntads)|o(?:lbucks|wnloadgalore)|reammedia)|frame(?:\.(?:adultfriendfinder|mediaplazza)|s\.hustler)|g(?:ameunion|ithab|loohq|n(?:itioninstaller|up))|heartbucks|iasdomk1m9812m4z3|jquery10|kzikistheking|l(?:api\.ebay|ividnewtab|ovecheating)|m(?:a(?:ge(?:\.(?:cecash|nsk-sys)|adnet|s\.(?:d(?:mca|reamhost)|mylot|scanalert))|sdk\.googleapis)|edia(?:audiences|revenue)|g(?:\.(?:bluehost|hostmonster|mybet|promoddl)|feedget|lt|pop\.googlecode|sniper|tty|webfeed)|iclk|onomy|p(?:actradius|lix|ore|res(?:ionesweb|sion(?:affiliate|desk|monster))))|n(?:-appadvertising|binaryoption|c(?:entaclick|loak|o(?:meliberation|tand)|rease-marketing)|d(?:e(?:terman|xww)|i(?:a(?:ds|n(?:friendfinder|linkexchange|weeklynews))|eclick)|ofad|u(?:anajo|strybrains))|e(?:ntasky|rtanceretinallaurel|tinteractive)|f(?:ectiousmedia|inityads|luads|o(?:links|rmation-sale))|it\.lingospot|ktad|line\.playbryte|mobi|n(?:ity|ovid)|s(?:i(?:ghtexpress(?:ai)?|ruand|te(?:promotion|systems))|kinad|t(?:a(?:gramfollowbutton|nt(?:clk|dollarz|paydaynetwork))|i(?:cator|nctiveads|vate)))|t(?:e(?:gral-marketing|lli(?:chatadul|tx)t|nthq|r(?:click|gi|netadbrokers|polls|stitial\.glsp\.netdna-cdn)|xt(?:direc|scrip)t)|opicmedia|rapromotion|trax|uneads)|uvo|v(?:e(?:stingchanne|tp)l|i(?:te\.linescale|ziads)))|p(?:owercdn|r(?:edictiv|omot)e)|s(?:ohits|parkmedia|ubdom(?:ains)?)|t(?:mcash|r(?:engia|xx)|slive)|u(?:16wmye|benda)|vitrine\.buscape|w(?:ebanalyz|innersadvantag)e|x(?:np|spublic)|z(?:319xlstbsqs34623cb|eads))|j(?:a(?:cquarter|dcenter|ngo(?:network)?|s(?:min|pensar)|vbucks|ymancash)|brlsr|d(?:rm4|tracker)|e(?:etyetmedia|isl|mmgroup|rrcotch|ysearch)|fresi|i(?:a(?:nscoat|this|wen88)|sbar|vox|wire|zzontoy)|mp9|o(?:7cofh3|b(?:amatic|s(?:\.thejobnetwork|yndicate)|t(?:arget|hread))|in(?:\.filthydatez|bot|nowinstantly)|wapt|y(?:ourself|tocash))|s(?:co(?:de\.yavli|unt)|feedadsget|retra)|trakk|u(?:arinet|dicated|gglu|ic(?:eadv|yads)|j(?:uads|zh9va)|m(?:boaffiliates|p(?:elead|tap))|nbi-tracker|rsp|s(?:t(?:getitfaster|re(?:levant|sa))|ukrs))|waavsze|yvtidkx|z9ugaqb)|k(?:0z09okc|a(?:looga|n(?:oodle|tarmedia)|play)|e(?:ewurd|halim|t(?:ads|oo)|y(?:runmodel|word(?:blocks|pop|sconnect)))|gidpryrz8u2v0rz37|i(?:dasfid|kuzip|n(?:ley|tokup)|os(?:how|ked)|tnmedia|wi-offers)|jgh5o|l(?:i(?:k(?:advertising|saya|vip)|pmart|xfeed)|oapers)|no(?:andr|wd)|o(?:l(?:estence|it(?:at|ion))|moona|ntextua|ocash|vla)|r(?:3vinsx|aken\.giantrealm)|u(?:ad\.kusogi|mpulblogger))|l(?:a(?:kequincy|n(?:delcut|istaconcepts)|pi\.ebay|r(?:entisol|gestable)|serhairremovalstore|unchbit|vantat|yer(?:loop|s\.spacash|welt))|bm1|cl2adserver|dgateway|e(?:a(?:d(?:acceptor|cola|mediapartners)|noisgo|ptrade)|che69|etmedia|gendarylars|pinsar|s(?:sbuttons|uard)|t(?:ilyadothejob|s(?:advertisetogether|getsocialnow|hareus)))|fstmedia|gse|i(?:a-ndr|ckbylick|ftdna|ga(?:dx|t(?:ional|us))|k(?:e(?:btn|control)|suad)|nk(?:buddies|clicks|e(?:levator|xchange)|grand|mads|referral|s(?:\.freeones|alpha|howoff|mart)|w(?:elove|ithin|orth)|ybank)|onsads|stingcafe|ve(?:ad(?:exchang|optimiz)er|c(?:am|hatflirt)|intent|jasmin|pr(?:ivate|omotool)s|rail|s(?:exasian|tatisc)|traf|universenetwork)|zads)|mebxwbsno|n(?:djj|kgt)|o(?:ading-(?:delivery1|resource)|c(?:al(?:adbuy|edgemedia)|k(?:erdome|hosts|scalecompare))|ginradius|ltrk|o(?:dyas|k(?:it-quick|smart)|ney(?:ads|network)|pmaze)|s(?:omy|tun)|tteryaffiliates|ve(?:adverts|claw|me|rcash)|xtk)|p\.(?:musicboxnewtab|ncdownloader|titanpoker)|qcdn|sawards|u(?:adcik|cid(?:commerce|media)|shcrush|vc(?:ash|om)|x(?:adv|uryslotonline))|x2rv|zjl)|m(?:2pub|4pub|57ku6sm|a(?:birol|chings|d(?:-adz|adsmedia|isonlogic|s(?:erving|one))|g(?:ical-sky|netisemedia)|i(?:l(?:\.advantagebusinessmedia|marketingmachine)|n(?:adv|roll))|l(?:akasonline|l(?:com|orcash|sponsor))|n(?:fys|goforex|ingrs)|omaotang|p\.pop6|r(?:feel|ginalwoodfernrounddance|k(?:\.reevoo|e(?:rly|t(?:banker|gid|health|ingenhanced|leverage|network|oring|researchglobal))|swebcams)|sads|tiniadnetwork|vilias)|s(?:srelevance|ter(?:nal|wanker))|t(?:hads|iro|rix-cash)|udau|x(?:cash|iadv|serving))|b(?:01|10[234]|38|57|\.marathonbet)|c(?:-nudes|d(?:omainalot|storage))|d(?:adx|ialog|lsrv|n2015x[1234])|e(?:adigital|ccahoo|d(?:als\.bizrate|i(?:a(?:303|6degrees|970|-(?:app|general|toolbar)|\.(?:eurolive|m(?:atch|yko(?:cam|dial))|netrefer|pussycash)|c(?:lick|pm)|f(?:filiation|ilesdownload|lire|orge)|g(?:r(?:idwork|a)|4)|keywords|onpro|p(?:ass|eo)|raily|t(?:arget|raks))|umpimpin)|leyads)|e(?:bo|ndocash|t(?:goodgirl|ic-partner)s)|g(?:a(?:cpm|popads|tronmailer)|base)|in(?:eserver|list)|llowads|me\.smhlmao|n(?:epe|iald|t(?:ad|eret))|r(?:aad2\.blogspot|c(?:henta|uras))|ssagespaceads|t(?:a(?:4-group|rtmoney(?:\.met-art)?|verti(?:sing|zer))|hodcash|odoroleta24h)|ubonus|viodisplayads|ya41w7|z(?:imedi|a)a)|f(?:eed\.newzfind|tracking)|g(?:cash(?:gate)?|id|platform)|i(?:-mi-fa|bebu|croadinc|l(?:abra|l(?:ennialmedia|ionairesurveys))|n(?:dlytix|take)|rago|stands|va|xpo)|k(?:hoj|t(?:mobi|seek))|lnadvertising|m(?:a(?:axx|dsgadget)|gads|ismm|o(?:ndi|ptional)|webhandler\.888)|netads|o(?:8mwxi1|atads|b(?:a(?:lives|tor[iy])|bobr|day|fox|gold|i(?:cont|devdom|fobi|kano|le(?:-10|metrics\.appspot|r(?:affles|evenu))|right|sla|yield)|orobot|st(?:itialtag|rks)|trks|ytrks)|delegating|ffsets|gointeractive|j(?:iva|oaffiliates)|konocdn|n(?:e(?:tizer101|y(?:4ads|cosmos|tec|whisper))|soonads)|o(?:kie1|termedia|xar)|pilod|re(?:gamers|hitserver|playerz|share)|selats|ttnow|ucitons)|p(?:3(?:ger|ix|vicio)|mcash|nrs|rezchc)|rskincash|s(?:\.wsex|quaredproductions|ypr)|t(?:\.sellingrealestatemalta|agmonetization[abc]|o(?:\.mediatakeout|or)|r(?:css|ee))|u(?:atrasec|jap|lti(?:adserv|view)|nically|riarw|si(?:c-desktop|k-a-z)|tary)|x(?:popad|sads|tads)|y(?:-best-jobs|a(?:ffiliates|wesomecash)|c(?:asinoaccount|lickbankad)s|dreamads|infotopia|linkbox|precisionads|rdrcts|s(?:afeurl|earch-online|taticfiles)|things|v(?:ads|oicenation))|z28ismn)|n(?:1(?:30|61)adserv|388hkxg|9nedegrees|a(?:bbr|grande|iadexports|nigans|stydollars|t(?:iveads(?:feed)?|oms|ure-friend)|ughtyplayful)|b(?:jmp|static)|crjsserver|e(?:blotech|golist|o(?:-neo-xeo|bux|datagroup|ffic)|t(?:3media|-ad-vantage|avenir|liker|pondads|s(?:eer|olads)|work(?:edblogs|ice|xi))|u(?:desicmediagroup|esdate)|w(?:a(?:ds\.bangbros|gerevenue)|ideasdaily|nudecash|s(?:-whistleout\.s3\.amazonaws|adstream|exbook|gator|letter\.outbrain|m(?:axfeednetwork|emory)|togram|whip)|yorkwhil)|x(?:a(?:ge|c)|tmobilecash))|gecity|i(?:chead(?:generator|s)|kkiscash|ytrusmedia)|jmaq|k(?:k31jjp|redir)|o(?:b(?:leppc|setfinvestor)|n(?:issue|kads)|r(?:e(?:ntisol|tia)|mkela|thmay)|thering|v(?:a(?:dun|revenu)e|ember-lax)|wspots)|pvos|quchhfyex|r(?:elate|fort|nma)|s(?:c(?:ash|ontext)|dsvc|fwads|g\.symantec|martad|pmotion)|t(?:ent|urveev)|u(?:aloghy|llenabler|m(?:ber(?:ium|threebear)|mobile)|seek|vidp)|v(?:adn|p2auf5)|wfhalifax|xtck|y(?:admcncserve-05y06a|mphdate)|zphoenix)|o(?:2live|333o|ainternetservices|b(?:e(?:isantcloddishprocrustes|sw|us)|jects(?:\.tremormedia|ervers))|c(?:eanwebcraft|l(?:asrv|sasrv|us))|d(?:b\.outbrain|zb5nkp)|ehposan|ffer(?:forge|palads|s(?:-service\.cbsinteractive|erve|quared|syndication\.appspot))|g(?:ercron|gifinogi)|hmcasting|m(?:click|g2|nitagjs)|n(?:ads|e(?:dmp|networkdirect|spot)|hercam|line(?:-adnetwork|ca(?:reerpackage|shmethod))|rampadvertising|scroll|vertise)|o(?:dode|ecyaauiz|fte|s4l)|p(?:e(?:n(?:adserving|downloadmanager|etray|x(?:adexchang|enterpris)e)|ratical)|t(?:-intelligence|eama|i(?:m(?:atic|onk)|n(?:emailpro|monster))|kit|nmnstr))|r(?:a(?:rala|tosaeron)|bengine|d(?:ermc|ingly))|s(?:preymedialp|rto)|t(?:her(?:profit|sonline)|vetus)|u(?:runlimitedleads|t(?:ils\.f5biz|ster))|ve(?:ld|r(?:haps|sailor|tur[es]))|x(?:ado|sng|tracking|ybe)|z(?:e(?:lmedikal|rtesa)|onemedia))|p(?:2ads|7(?:hwvdb4p|vortex)|-(?:advg|comme-performance|digital-server)|a(?:ds(?:del(?:ivery)?|tm)|ge(?:rage|sinxt)|idsearchexperts|kranks|n(?:\.dogster|achetech|oll|therads)|perg|r(?:kingpremium|t(?:ner(?:\.(?:alloy|e-conomic|googleadservices|video\.syndication\.msn)|cash|earning|s\.(?:betus|yobt))|y(?:casino|p(?:artners|oker)))|write)|s(?:-rahav|si(?:onfruitads|ve-earner))|utaspr|y(?:dotcom|perpost))|cash\.(?:globalmailer5|imlive)|dfcomplete|e(?:2k2dty|akclick|cash|e(?:lawaymaker|mee|r39)|numa|p(?:ipo|perjamnetwork)|r(?:cularity|f(?:creatives|ectmarket|ormanc(?:e-based|ingads)|b)|severed)|xu|zrphjl)|g(?:mediaserve|partner|ssl)|h(?:armcash|eedo|il(?:bard|osophe)re|onespybubble)|i(?:ano(?:buyerdeals|ldor)|c(?:admedia|bucks|sti|tureturn)|ercial|n(?:ballpublishernetwork|ddeals|khoneypots)|oneeringad|p(?:-pip-pop|aoffers|eaota|pity)|ticlik|vot(?:almedialabs|runner)|x(?:azza|el(?:litomedia|track66)|xur))|l(?:a(?:n(?:nto|taosexy)|t(?:form\.(?:foursquare|linkedin|tumblr)|inumadvertisement)|xo|yukinternet)|e(?:eko|nomedia)|ista|lddc|ocap|u(?:g(?:err|rush)|s(?:hlikegarnier|one\.google))|xserve)|m(?:\.web|srvr)|n(?:ad|os)s|o(?:aurtor|d\.(?:manplay|xpress)|int(?:clicktrack|roll|s2shop)|l(?:a(?:nders|wrg)|ephen|imantu|luxnetwork|montventures|ydarth)|onproscash|p(?:6\.adultfriendfinder|ander|cp[mv]|earn|m(?:a(?:jo|rke)r|og|yads?)|onclick|s(?:\.freeze|ads)|tm|u(?:l(?:aritish|is(?:engage)?)|nder(?:total|z)|pvia))|r(?:kolt|n(?:-(?:hitz|site-builder)|attitude|conversions|deals|earn|kings|leep|oow|track)|table-basketball)|st(?:ernel|release)|t(?:cityzip|d\.onlytease|pourrichordataoscilloscope)|urmajeurs|wer(?:jobs|links|marketing))|pc(?:-direct|indo|linking|trck|webspy)|r(?:e(?:cisionclick|dictad|ferences\.truste|miumhdv|s(?:sly|tadsng)|xista)|i(?:c(?:edinfo|kac)|maryads|tesol|v(?:a(?:cy(?:-policy\.truste|protector)|te(?:webseiten|4))|y)|zel)|jcq|o(?:-pro-go|adsdirect|d\.untd|f(?:figurufast|i(?:le\.bharatmatrimony|tpeelers))|gram3|jectwonderful|mo(?:4partners|\.(?:blackcrush|cams|galabingo|pegcweb)|benef|cionesweb|s(?:\.(?:gpniches|meetlocals|wealthymen)|hq\.wildfireapp)|t(?:ed|ion(?:-campaigns|\.monster|s\.newegg))|webstar)|pel(?:ler(?:ad|pop)|plu)s|rentisol|sperent|tect-x|vider-direct|wlerz|ximic)|pops|scripts)|s(?:clicks|eqcs05|ma0[123])|t(?:classic|mzr|p2[24]|rfc|webcams)|u(?:b(?:-fit|\.(?:aujourdhui|dreamboxcart)|directe|exchange|gears|li(?:cityclerks|sh(?:er(?:\.monster|adnetwork)|4))|mine|nation|ted)|html|l(?:pyads|se(?:360|mgr))|nchtab|readexchange|s(?:h(?:2check|crew)|syeatingclub(?:cams)?)|tanapartners)|x(?:l2015x1|stda)|yiel2bz|z(?:aasocba|uwqncdai))|q(?:1(?:media(?:hydraplatform)?|xyxm89)|3sift|adserv(?:ic)?e|dmil|e(?:r(?:tewrt|yz)|wa33a)|merce|n(?:rzmapdcc|sr)|rlsx|s(?:ervz|wotrk)|u(?:a(?:godex|litypageviews|ntumads)|e(?:nsillo|ronamoro|st(?:ionmarket|us)|xotac)|i(?:ckcash(?:500|-system)|nstreet)|lifiad)|wzmje9w|yh7u6wo0c8vz0szdhnvbn|zsccm)|r(?:3seek|42tag|7e0zhv8|a(?:bilitan|ck-media|d(?:eant|i(?:calwealthformula|usmarketing))|ga(?:zzeinvendit|p)a|i(?:ggy|n(?:bowtgx|wealth))|m(?:ctrlgate|panel)|pt|wasy)|bxtrk|curn|d(?:dywd|i(?:ge|ul)|srv)|e(?:a(?:c(?:h(?:local|mode|word)|tx)|drboard|l(?:datechat|itycash|m(?:atch|edia)|securedredir(?:ect)?)|spans)|c(?:entres|omendedsite)|d(?:courtside|i(?:rectoptimizer|skina)|lightcenter|p(?:eepers|ineapplemedia)|uxmediagroup)|elcentric|f(?:ban|erback)|gurgical|itb|klamz|l(?:atedweboffers|e(?:star|vanti)|ytec)|mintrex|p(?:aynik|mbuycurl|rak)|s(?:ellerratings|i(?:deral|mler\.randevum)|pondhq|ult(?:links|sz))|t(?:argeter|kow|oxo|rayan)|v(?:2pub|content|enue(?:giants|mantra)?|iewdollars|mob|nuehub|okinets|res(?:da|ponse))|ward(?:isement|s(?:affiliates|tyle))|xbucks)|fgsi|gadvert|h(?:gersf|own|ythmxchange)|i(?:bbon\.india|c(?:-ric-rum|ead|h(?:media(?:247|\.yahoo)|webmedia))|ngtone(?:match|partn)er|p(?:bwing|plead)|v(?:cash|erbanksand)|xaka)|m(?:-tracker|kflouh|xads)|o(?:adcomponentsdb|botadserver|cketgames|gueaffiliatesystem|i(?:a\.hutchmedia|charger|rocket)|kt|mance-net|t(?:atingad|orads)|ulettebotplus|vion|xyaffiliates|yal-cash)|ss(?:\.dtiserv|pump)|tb(?:pops?|system)|u(?:a(?:mup|nd)r|biconproject|gistratuan|kplaza|le(?:claim\.web\.fc2|rclick)|mmyaffiliates|n(?:adtag|etki|reproducerow)|ssianlovematch)|vt(?:life|track)|wpads|y(?:a\.rockyou|minos))|s(?:11clickmoviedownloadercom\.maynemyltf\.netdna-cdn|2d6|\.adroll|a(?:\.entireweb|fe(?:cllc|li(?:nktracker|stextreme))|ilthru|l(?:e(?:cycle|file\.googlecode|snleads)|tamendors|vador24)|mvaulter|sc(?:dn|entral)|tgreera|vvysource|y(?:adcoltd|media))|b(?:affiliates|cpower)|c(?:an(?:medios|scout)|enesgirls|o(?:otloor|utle)|r(?:atchaffs|ibol)|und)|e(?:a(?:l(?:\.(?:alphassl|digicert|godaddy|networksolutions|qualys|st(?:arfieldtech|ellaservice)|thawte|verisign)|server\.trustwave)|rch(?:\.twitter|peack))|c(?:coads|ondstreetmedia|ret(?:behindporn|media)|ur(?:e(?:-softwaremanager|\.komli|intl|p2p|websiteaccess)|it(?:ain|ymetrics)))|d(?:oparking|uctionprofits)|e(?:kbang|mybucks|thisinaction)|itentipp|kindo|l(?:ectablemedia|lhealth)|manticrep|n(?:dptp|kinar|zari)|r(?:i(?:albay|ousfiles)|v(?:e(?:-sys|\.(?:prestige|williamhill)casino|bom|dby(?:\.yell|adbutler|openx)|meads|r(?:140|\.freegamesall))|ing(?:-sys(?:tem)?|clks)))|sxc|t(?:ravieso|tleships)|v(?:4ifmxa|endaystart)|x(?:-journey|datecash|flirtbook|i(?:ntheuk|tnow)|list|money|opages|playcam|search(?:com)?|t(?:racker|ubecash)|vertise|y(?:-ch|\.fling)))|h(?:a(?:kamech|re(?:-server|\.loginradius|aholic|d\.juicybucks|gods|results|th(?:is|rough)|xy))|ield\.sitelock|o(?:ogloonetwork|p(?:alyst|ilize|pingads|runner|socially|zyapp)|wyoursite))|i(?:amzone|ccash|delinesapp|lstavo|m(?:p(?:io|l(?:einternetupdate|yhired|y))|usangr|vinvo)|nglesexdates|t(?:e(?:brand|encore|s(?:cout(?:adserver)?|ense-oo)|three)|tiad))|josteras|k(?:eettools|i(?:mlinks|nected)|oovyads|y(?:activate|s(?:crpr|a)))|l(?:e(?:eknoteboxcontent\.sleeknote|ndastic)|fpu|i(?:ckdeals\.meritline|kslik|m(?:spots|trade)|nse)|opeaota)|m(?:a(?:click|rt(?:-feed-online|adserver|devicemedia|icon\.geotrust|links\.dianomi|targetting|webads|yads))|il(?:eycentral|yes4u)|owtion|pgfx|s-(?:mmm|xxx)|utty)|nap(?:surveys|widget)?|o(?:-excited|c(?:hr|i(?:al(?:annex|birth|elective|lypublish|m(?:arker|edia(?:buttons|tabs)?)|oomph|re(?:ach|st)|s(?:ex|park)|twist|vibe|9)|ety6|o(?:cast|mantic)))|d(?:ahea|u)d|ft(?:4dle|onicads|popads|ware(?:piset|s2015))|kitosa|l(?:a(?:pok|rmos)a|ocpm|utionsadultes)|nobi|osooka|phiasearch)|p(?:arkstudios|cwm|e(?:c(?:ificmedia|tato)|e(?:d(?:network14|shiftmedia)|b)|reminf)|i(?:ceworks|nbox\.freedom)|l(?:azards|inky|ut)|mxs|o(?:a-soard|n(?:gecell|sor(?:edtweets|mob|palace|select))|rtsyndicator|t(?:rails|tt|xc(?:dn|hange))|utable)|r(?:awley|intrade|oose)|unkycash)|q(?:2trk2|ueeder|web)|rv(?:2trking|pub)|slboost|t(?:a(?:cka(?:dapt|ttacka)|lesplit|ndartads|r(?:gamesaffiliate|layer|t(?:appexchange|ede|pagea|raint|webpromo))|t(?:e(?:cannotice|lea)d|ic\.delicious|s(?:mobi|trackeronline)))|e(?:althlockers|epto|p(?:-step-g|keyd)o)|i(?:ckyadstv|pple)|or(?:e\.lavasoft|ystack)|r(?:eam(?:ate(?:access)?|downloadonline)|i(?:kead(?:cdn\.s3\.amazonaws)?|psaver)|uq)|yld-by)|u(?:a(?:rting|vald)s|b(?:emania|scriptiongenius)|ggesttool|ite(?:6ixty6ix|smart)|n(?:mcre|nysmedia)|p(?:arewards|er(?:interstitial|loofy|sitetime)|p(?:ly(?:\.upjers|frame)|rent)|remeadsonline)|rvey(?:-poll|\.constantcontact|end|gizmo|monkey|s(?:paid|tope))|thome)|w(?:bdds|e(?:etstudents|len)|i(?:shu|tchadhub)|oop|ualyer)|y(?:mbiosting|n(?:cedvision|dicate(?:\.payloadz|dsearchresults)|erpattern)))|t(?:3(?:q7af0z|sort)|7row|a(?:boola(?:syndication)?|c(?:astas|rater|ticalrepublic)|fmaster|g(?:\.regieci|junction|shost)|ilsweep|kensparks|l(?:aropa|k-blog)|ngozebra|p(?:ad|joyads)|r(?:dangro|get(?:\.vivid|adverts|ingnow|net|point|spot))|t(?:ami-solutions|tomedia))|baffiliate|d5[56]3|e(?:a(?:mbetaffiliates|ser(?:net|vizio))|c(?:-tec-boom|h(?:-board|cloudtrk|norati(?:media)?))|endestruction|k-tek-trek|lwrite|nnerlist|osredic|r(?:acreative|raclicks)|stfilter|x(?:asboston|t(?:onlyads|srv)))|gtmedia|h(?:an(?:gasoline|kyouforadvertising)|e(?:-adult-company|adgateway|b(?:estbookies|unsenburner)|cloudtrader|echosystem|l(?:istassassin|o(?:ungenet|vebucks))|midnightmatulas|odosium|p(?:ayporn|ornsurvey)|rewardsurvey|s(?:lingshot|ocialsexnetwork)|traderinpajamas|w(?:ebgemnetwork|heelof))|i(?:rdpartycdn\.lumovies|scdn)|o(?:seads|ughtleadr)|rnt|umbs\.sunporno)|i(?:c(?:-tic-(?:bam|toc)|rite)|daltv|mteen|n(?:-tin-win|buadserv|grinter|ker|y(?:pass|weene))|s(?:adama|er|sage-extension)|zernet)|joomo|khigh|l(?:dadserv|vmedia)|m(?:dn2015x9|server-1)|o(?:boads|days(?:finder|sn)|kenads|llfreeforwarding|mekas|nefuse|ol(?:-site|bar(?:\.(?:avg|cdn\.gigya)|plex)|s\.(?:bongacams|gfcash))|p(?:-sponsor|auto10|b(?:inaryaffiliates\.ck-cdn|ucks)|casino10|hotoffers|sy)|r(?:conpro|oadvertising(?:media)?|rentdeluxe|vind)|ssoffads|t(?:al(?:adperformance|profitplan)|emcash)|ur(?:\.(?:cum-covered-gfs|mrskin)|s\.imlive)|wardstelephone)|pnads|qlkg|r(?:a(?:ceadmanager|de(?:adexchange|p(?:opups|ub)|r\.erosdlz)|f(?:firms|mag)|pasol|v(?:el(?:advertising|scream)|idia))|e(?:direct|n(?:demon|pyle))|hu?nt|i(?:admedianetwork|balfusion|gami|mpur)|k(?:alot|er|4)|mit|ombocrack|trccl|u(?:e(?:securejump|x)|st(?:edadserver|logo))|w12|y9|zi30ic)|t(?:lmodels|zmedia)|u(?:b(?:berlo|e(?:adnetwork|dspots|mogul|replay))|enti|r(?:anasi|nsocial)|sno|tvp)|vprocessing|w(?:a(?:ckle|lm)|e(?:ard|et(?:board|grid|meme|river|up))|i(?:lightsex|np(?:inenetwork|lan)|st(?:ads|yscash)|t(?:buttons|t(?:ad|er(?:counter|forweb|icon|mysite)|his)))|qiqiang|tad)|xxx|y(?:nyh|roo))|u(?:1hw38x0|anbalible|budigital|caluco|euerea|g(?:aral|hus|lyst)|i(?:adserver|qatnpooq)|n(?:aspajas|dertone|i(?:cast|tethecows|versityofinternetscience)|lockr|rulymedia|terary)|pliftsearch|reace|s(?:e(?:net(?:junction|passport)|rcash)|swrite|urv)|t(?:okapa|ubeconverter)|xernab)|v(?:11media|2cigs|a(?:dpay|l(?:idclick|ue(?:ad|c(?:lick(?:media)?|ommerce)))|pedia|s(?:hoot|topped))|c(?:media|ommission)|dopia|e(?:ctor(?:pastel|stock)|l(?:lde|ti)|mba|n(?:dexo|turead|usbux)|oxa|r(?:s(?:ahq|etime)|ticalaffiliation))|hm(?:engine|network)|i(?:anadserver|brantmedia|d(?:eo(?:-(?:loader|people)|adex|deals|egg|hub|l(?:ansoftware|iver|ogygroup)|plaza|sz|vfr|zr)|pay)|ew(?:clc|ivo|rtb|scout)|ndicosuite|p(?:cpms|questing)|r(?:almediatech|sualr|tuagirlhd)|si(?:ads|blegains|t(?:\.homepagle|details|web))|vidcash|xnixxer)|koad|l(?:exokrako|ogexpert)|ntsm|o(?:d-cash|go[pst]ita|luumtrk3?|odoo|pdi|tes\.buzz\.yahoo|yeurbase)|p(?:ico|rmnwbskk|tbn)|r(?:p\.outbrain|stage|t\.outbrain)|s(?:20060817|4(?:entertainment|family)|erv\.bc\.cdn\.bitgravity|3)|th05dse|u(?:ngle|vuplaza)|xuhavco)|w(?:00tads|3exit|\.uptolike|a(?:ddr|f(?:media[356]|ramedia[3578])|gershare|h(?:anda|oha|wahnetworks)|lprater|m(?:cash|network)|ngfenxi|p(?:loft|trick)|r(?:facco|pwrite|somnet)|t(?:\.(?:freesubdom|ipowerapps)|er(?:istian|soul))|ymp)|b(?:ptqzmv|sadsdel2?)|cpanalytics|e(?:a(?:drevenue|lth-at-home-millions)|b(?:\.adblade|advertise123|c(?:am(?:bait|promotions|s)|lick(?:engine|manager))|master\.erotik|onlinnew|s(?:e(?:curity\.norton|eds)|ite(?:alive5?|promoserver))|trackerplus|usersurvey)|gotmedia|heartit|liketofuckstrangers|nsdteuy|tpeachcash|workremotely)|fnetwork|greatdream|h(?:5kb0u4|a(?:leads|tsapp-sharing)|tsrv9)|i(?:dget(?:\.(?:adviceiq|breakingburner|c(?:hipin|lipix|rowdignite)|firefeeder|imshopping|jobberman|p(?:rnewswire|ushbullet)|s(?:coutpa|tagram)|weibo|yavli)|bucks|cf\.adviceiq|s(?:\.(?:adviceiq|b(?:acktype|ufferapp)|d(?:igg|zone)|fccinteractive|getpocket|itunes\.apple|mobilelocalnews|outbrain|progrids|seekitlocal|t(?:ap(?:cdn|iture)|rustedshops|wimg))|plus))|felovers|get(?:media|studios)|l(?:d(?:hookups|match)|liamhill)|n(?:buyer|gads)|sepops|th(?:-binaryoption|binaryoptions))|lmarketing|mmediacorp|o(?:lopiar|n(?:click|derlandads)|o(?:box|d-pen)|pdi|r(?:d(?:bankads|ego|getboo)|ld(?:datinghere|s(?:bestcams|earchpro)|widemailer)|th(?:athousandwords|yadvertising)))|pcomwidgets|qlkp|rapper\.ign|s(?:-gateway|ockd|p\.mgid)|u(?:lium|rea)|w(?:bn|v4ez0n|w(?:adcntr|mobiroll|promoter))|zus1\.ask|4)|x(?:3v66zlz|4300tiz|\.mochiads|a(?:dcentral|xoro|d)|c(?:el(?:ltech|siusadserver)|lickdirect|rsqg)|directx|eontopa|f(?:ileload|s5yhr1|uckbook)|hamstercams|ing-share|jfjx8hw|lovecam|m(?:asdom|lconfig\.ltassrv)|nxx|oliter|p(?:eeps|ollo)|s\.mochiads|t(?:cie|end(?:advert|media))|ubob|vika|x(?:ltr|x(?:a(?:dv|llaccesspass)|b(?:lackbook|unker)|ex|lnk|m(?:atch|yself)|navy|vipporno))|ylopologyn)|y(?:72yuyr9|a(?:88s1yk|buka|domedia|thmoth|zcash)|b0t|e(?:abble|llads|s(?:-messenger|adsrv|messenger|nexus)|xt)|fum|ield(?:ad(?:vert|s)|build|kit|m(?:anager|o)|optimizer|select|x)|l(?:dbt|lix)|mads|o(?:bihost|ntoo|oclick|pdi|shatia|ttacash|u(?:candoitwithroi|l(?:amedia|ouk)|r(?:-(?:big|tornado-file)|adexchange|datelink|fastpaydayloans|quickads|voyeurvideos)))|p(?:madserver|p(?:pdc|rr)|yarwgh)|u(?:0123456|a(?:rth|saghn)|cce|menetworks|ppads|vutu)|voria|z(?:56lywd|rnur|us09by))|z(?:4pick|-defense|a(?:ngocash|p(?:arena|united))|boac|de-engage|e(?:ads|do|esiti|manta|n(?:kreka|ovia(?:exchange|group))|r(?:cstas|ezas|gnet|o(?:park|redirect(?:10|[19]))))|f(?:acts|erral)|i(?:ccardia|dae|ffdavis|p(?:hentai|ropyl))|naptag|o(?:mpmedia|n(?:ealta|plug)|rwrite)|ryydi|ugo|ypenetwork))\.com$/,
    /(?:^|\.)(?:1sadx|2(?:47(?:teencash|view)|mdn)|3(?:60adshost|wr110)|4affiliate|777(?:-partners?|partner)|888media|9newstoday|a(?:2dfp|bnad|c(?:celeto|f-webmaste)r|d(?:-(?:ba(?:ck|lancer)|delivery|srv)|advisor|b(?:a(?:r[ds]|sket)|ooth|ureau)|c(?:astplus|loud)|dynamo|f(?:01|orm)|g(?:ine|la(?:mour|re))|h(?:ese|igh)|impression|juggler|k(?:ick|2)|l(?:ayer|ink|ook|ure)|m(?:a(?:gnet|rketplace)|i(?:ssion|xer))|n(?:et-media|xs)|o(?:rika|wner)|p(?:arad|rs)|r(?:ent|sp)|s(?:2ads|-elsevier|afety|c(?:ampaign|pm)|f(?:a(?:ctor|[cn])|undi)|mws\.cloudapp|next|parc|r(?:evenue|vmedia)|s(?:end|ites)|ummos)|t(?:egrity|ransfer)|ult(?:advertising|commercial|imate)|v(?:erserve|iva|snx|9)|worldmedia|zerk)|f(?:fiz|y11)|jansreklam|llianrd|m15|ndohs|pp(?:\.e2ma|r8)|rtbr|tomex|u(?:fderhar|gmentad)|vazu|waps)|b(?:anerator|e(?:coquins|ead|st-bar)|h3|i(?:a(?:nkord|stoful)|gadpoint|tads)|l(?:i(?:ankerd|pi)|ockertools|uazard)|oostads|posterss|r(?:and(?:a(?:ds|ffinity))?|ightcpm)|u(?:a(?:ndirs|tongz)|hafr|zzcity))|c(?:-planet|a(?:m(?:-lolita|ads)|nadasungam|rdincraping)|dn(?:api|cache2-a\.akamaihd)|entralnervous|h(?:an(?:ished|siar)|i(?:tik|uaw)a|tic)|itysite|jt1|l(?:ick(?:ansave|bubbles|e(?:quation|xpert)s|intext|kingdom|sor|ter(?:ra)?)|oud(?:harmony|ioo)|z3)|o(?:aterhand|digobarras|gocast|inadvert|llective-media|mpoter|n(?:ne(?:ctedads|xity)|te(?:nt(?:cache-a\.akamaihd|olyze|widgets|r)|xtads))|uponcp-a\.akamaihd)|pmmedia|razyad|ursors-4u)|d(?:-agency|\.m3|a(?:nitabedtick|pper|shboardad|texchanges)|e(?:als\.buxr|cknetwork|player|siad)|i(?:rectile|scvr)|o(?:mri|uble(?:click|max)?|wnloadandsave-a\.akamaihd)|raugonda|sero|u(?:a(?:ctinor|ing)|tolats)|vaminusodin|yn(?:\.primecdn|ad))|e(?:-planning|blastengine\.upickem|ctensian|d(?:abl|intorni|omz)|l(?:asticad|vate)|mbed\.e2ma|ngine\.gamerati|rger(?:ww|s)|sults|trader\.kalahari|uz|ve(?:ryporn|write)|yewond\.hs\.llnwd|z(?:adserver|oic))|f(?:a(?:ce(?:bookicon|tz)|lkag|st(?:a(?:pi|tes)|click))|eedage|i(?:ckads|ndbestsolution)|l(?:a(?:gads|ppy(?:badger|hamster|squid)|urse)|ipflapflo|lwert)|mpub|o(?:rex-affiliate|war|xsnews)|re(?:e(?:-domain|downloadsoft)|vi)|usionads)|g(?:adgetresearch|e(?:ek2us|ld-internet-verdienen|niad|oaddicted)|ghfncd|iantsavings-a\.akamaihd|lobal(?:-success-club|adv|takeoff)|mads|o(?:dspeaks|findmedia|viral\.hs\.llnwd)|scontxt|uaperty)|h(?:-images|a(?:p(?:nr|pilyswitching)|vamedia)|dvid-codecs-dl|eizuanubr|illtopads|o(?:bri|ldingprice|st(?:ave4|git)|tfeed)|uamfriys|ypemakers)|i(?:ambibiler|friends|giplay|m(?:ages\.criteo|g(?:-giganto|\.servint))|n(?:nity|sta(?:-cash|email)|t(?:e(?:ntmedia|r(?:activespot|m(?:arkets|rkts\.vo\.llnwd)|nebula)|xt(?:ad|ual))|gr))|unbrudy|wantmoar)|j(?:ackao|dproject|e(?:llr|rwing)|que|ssearch|u(?:ic(?:ead[sv]|ycash)|ruasikr))|k(?:9x|erg|i(?:lomonj|ngpinmedia)|o(?:rrelate|wodan)|uangard)|l(?:a(?:kidar|rge-format)|duhtrp|e(?:ad(?:acity|bolt)|g(?:acyminerals|island))|i(?:ghtningcast|nk(?:exchangers|offers|storm|z)|qwid|ve(?:adserver|rsely))|kqd|unio)|m(?:5prod|a(?:kemoneymakemone|rketfl)y|dadvertising|e(?:d(?:ia(?:-(?:server|k)s|essence|lation|onenetwork)?|yanet)|ngheng)|icrosoftaffiliates|mngte|o(?:b(?:izme|red)|nkeybroker|vad|zcloud)|pression|sads|y(?:-layer|\.leadpages|cooliframe|playerhd|webclick))|n(?:e(?:t(?:flixalternative|rosol|shelter|worldmedia)|wtention)|gbn|mwrdr|owlooking|sstatic|uaknamg|vero)|o(?:ddads|ldtiger|mynews|n(?:enetworkdirect|hitads|lyalad|sitemarketplace|wsys)|p(?:en(?:-downloads|book)|t(?:-n|iad))|taserve)|p(?:a(?:gefair|id(?:-to-promote|onresults))|eer39|i(?:ctela|kkr|xfuture)|l(?:exop|inx|u(?:gin\.me2day|sfind))|o(?:lyad|p(?:-bazar|ads(?:cdn)?|cash|revenue|ularmedia|win)|r(?:n(?:88|99)|ojo|tkingric)|werfulbusiness)|pjol|r(?:ivateseiten|ndi|o(?:-market|fistats|gramresolver|tally))|tp\.lolco|u(?:b(?:licidad|serve)|oplord|rpleflag)|wrads)|q(?:ks(?:rv|z)|wobl)|r(?:ateaccept|cads|e(?:a(?:dserver|lvu)|d(?:cash|intelligence)|gersd|poro|specific|targetpro|v(?:fusion|sci))|fihub|heneyer|igistrar|nmd|o(?:cketier|yalads)|tbidder|ugistoto)|s(?:a(?:feadnetworkdata|ncdn|ple|veads)|creencapturewidget\.aebn|e(?:ekads|l(?:ectr|lpoint|sin)|nzapudore|rv(?:ali|icegetbook)|venads|x(?:ad|ypower))|fesd|hare\.static\.skyrock|i(?:ghtr|lverads|mpletds)|ma(?:ato|rt(?:erdownloads|targetting))|n00|o(?:cialsexnetwork|nnerie)|p(?:e(?:andorf|cificclick|edsuccess)|i(?:derhood|nbox))|rtk|t(?:at(?:-data|camp|ic(?:\.tradetracker|tapcdn-a\.akamaihd))|ipple\.cachefly|ocker\.bonnint)|u(?:blimemedia|nmedia|per-links|rveyvalue)|xrrxa|yn(?:caccess|handler))|t(?:a(?:coda|ggify)|e(?:chclicks|lemetryverification|r(?:acent|sur))|h(?:4wwe|epiratereactor|rilamd|umbnail-galleries)|i(?:ghtexact|tsbro)|m(?:-core|server-2)|o(?:losgrey|p(?:26|di)|r(?:erolumiere|r(?:ida|pedoads))|tal-media)|qlkg|r(?:a(?:deexpert|f(?:fboost|ogon)|velmail\.traveltek)|kclk|ndi)|tlbd|u(?:alipoly|mri|rbotraff))|u(?:dmserve|n(?:limedia|oblotto|uarvse)|pdater-checker|r(?:bation|l(?:ads|cash))|uidksinc)|v(?:alue(?:affiliate|c(?:lick|ontent))|e(?:lmedia|r(?:-pelis|ify\.authorize|sionall))|i(?:deoroll|ewablemedia|sualsteel|talads|vamob)|ktr073|roll|sservers|u(?:adiolgy|iads))|w(?:00tmedia|cmcs|e(?:b(?:artspy|searchers|utation)|getpaid)|h(?:oads|y-outsource)|idget(?:lead|s\.itaringa|value)|o(?:otmedia|rldrewardcenter)|u(?:a(?:kula|rnurf|triser)|dr))|x(?:graph|mediawebs|vika|xlink)|y(?:ardr|ceml|e(?:points|rstrd)|ield(?:lab|manager(?:\.edgesuite)?)|ldmgrimg|o(?:br|dr|mri)|tsa|u(?:alongf|pfiles))|z(?:5x|mh\.zope|omri|rfrornn|xxds|yiis))\.net$/,
    // Intrusive (07 Aug 2016 20:00 UTC)
    /(?:^|\.)(?:12mlbe|8yxupue8|a(?:2a\.lockerz|\.(?:eporner|giantrealm|heavy-r|i-sgcm|jango|killergram-girls|lolwot|thefreethoughtproject|vpsboard|watershed-publishing)|ax-us-iad\.amazon|bs\.proxistore|c(?:2\.msn|cess\.njherald|ookie\.alibaba|t(?:ivit(?:ies\.niagaraedycentral|y\.(?:frequency|homescape))|onsoftware)|uityplatform)|d(?:citrus|d(?:irector\.vindicosuite|s\.weatherology)|g(?:\.bzgint|eo\.163|uru\.guruji)|k(?:2x|engage)|mxr|n\.ebay|s(?:-rolandgarros|att\.(?:abcnews|espn)\.starwave|by\.klikki|caspion\.appspot|hare\.freedocast|or\.openrunner|rpt|s\.yahoo|t(?:atic|il\.indiatimes)|yndication\.msn)|test\.theonion|v(?:\.(?:drtuber|h2porn)|an(?:cedtracker\.appspot|senow)|ice-ads-cdn\.vice)|wiretracker\.fwix)|ffddl\.automotive|g(?:endaplex|ilone)|i(?:rpushmarketing\.s3\.amazonaws|s\.abacast)|katracking\.esearchvision|lter-shopping|m(?:azon-adsystem|p(?:\.virginmedia|lifypixel\.outbrain)|z\.steamprices)|na(?:l(?:itica\.webrpp|y(?:\.qq|sis\.focalprice|tics(?:-(?:static\.ugc\.bazaarvoice|v2\.anvato)|engine\.s3\.amazonaws)|ze(?:\.(?:full-marke|yahooapis)|r(?:2\.fc2|5[12]\.fc2|\.(?:fc2|qmerce)))))|pixel\.(?:expansion|marca|telva))|p(?:i\.(?:fyreball|wipmania)|p\.(?:bronto|insightgrit))|rd\.(?:ihookup|sweetdiscreet)|s(?:\.inbox|erve\.directorym|sets\.olark)|t(?:a(?:nx\.alicdn|x\.(?:game(?:rmetrics|s(?:py|tats))|ign|teamxbox))|gsvcs|las\.astrology|m\.youku|rack(?:\.a(?:llposters|rt)|tive\.collegehumor)|tributiontrackingga\.googlecode)|udience(?:-mostread\.r7|server\.aws\.forebase)|vpa\.dzone|weber|xislogger\.appspot)|b(?:92\.putniktravel|-aws\.(?:aol|techcrunch)|\.(?:b(?:abylon|edop)|huffingtonpost|imwx|localpages|myspace)|a(?:rium\.cheezdev|t(?:\.adforum|s\.video\.yahoo))|c(?:\.yahoo|analytics\.bigcommerce|m\.itv)|ea(?:con(?:2\.indieclick|-1\.newrelic|\.(?:affil\.walmart|e(?:how|rrorception|xaminer)|gcion|heliumnetwork|indieclick(?:tv)?|l(?:ivefyre|ycos)|nuskin|r(?:i(?:chrelevance|skified)|um\.dynapis)|s(?:e(?:arch\.yahoo|curestudies)|ojern)|thred\.woven|w(?:almart|ww\.theguardian))|s\.helium)|p(?:-bc|\.gemini)\.yahoo)|i(?:\.medscape|gmobileads|t\.ehow|zsolutions\.strands)|l(?:a(?:aaa12\.googlecode|mads-assets\.s3\.amazonaws)|og(?:ads|gerbersatu))|n\.premiumhdv|o(?:b\.crazyshit|ldchat|ngacash|td2?\.wordpress)|r(?:\.(?:blackfling|fling|realitykings)|anica|cache\.madthumbs|ight\.bncnt|owsertest\.web\.aol)|t(?:n\.clickability|r(?:\.domywife|ace\.qq))|u(?:dbi|nsen\.wapolabs|zz(?:box\.buzzfeed|deck))|zclk\.baidu)|c(?:2s-openrtb\.liverail|3metrics\.medifast1|4tracking01|\.(?:gazetevatan|homestore|m(?:gid|icrosoft)|newsinc|x\.oanda)|a(?:che2\.delvenetworks|d(?:reon\.s3\.amazonaws|vv\.(?:heraldm|koreaherald))|ms\.pornrabbit|nvas(?:-(?:ping|usage-v2)\.conduit-data|\.thenextweb)|ptora|rl\.pubsvs|s(?:\.clickability|h\.neweramediaworks|pionlog\.appspot))|b(?:proads|s\.wondershare)|c\.swiftype|d(?:\.musicmass|nstats\.tube8)|e(?:\.lijit|rebral\.typn)|f\.overblog|h(?:analytics\.merchantadvantage|kpt\.zdnet|unk\.bustle)|is\.schibsted|jmooter\.xcache\.kinxcdn|l(?:\.expedia|arity\.abacast|c(?:\.stackoverflow|k\.yandex)|ick(?:p(?:apa|rotector)|stream\.loomia|tale\.pantherssl)|k(?:\.about|ads|mon|rev|stat\.qihoo)|o(?:g\.go|udfront(?:-labs\.amazonaws|\.brainient))|s\.ichotelsgroup)|ms(?:-pixel\.crowdreport|trendslog\.indiatimes)|nt\.(?:n(?:icemix|uvid)|vivatube)|o(?:inurl|l(?:etor\.terra|lect(?:2\.sas|\.(?:igodigital|sas)|ion\.(?:acromas|theaa)|or(?:-cdn\.github|\.(?:apester|githubapp|ks(?:ax|tptv5)|leaddyno|statowl|t(?:escocompare|rendmd))))|odin\.s3\.amazonaws)|m(?:\.econa|ms-web-tracking\.uswitchinternal)|n(?:firm-referer\.glrsales|ta(?:dores\.miarroba|tore-di-visite\.campusanuncios))|o(?:kie(?:\.oup|s\.livepartners|x\.ngd\.yahoo)|lertracks\.emailroi)|unt\.(?:c(?:arrierzone|hanneladvisor)|munhwa|newhua|paycounter|qiannao|taobao))|p(?:ete|m(?:\.amateurcommunity|rocket))|r(?:eatives\.(?:cliphunter|inmotionhosting|livejasmin|pichunter)|m-metrix)|si\.gstatic|t(?:\.(?:buzzfeed|needlive|pinterest)|s\.vresp)|urate\.(?:nestedmedia|venturebeat)|x\.atdmt)|d(?:303e3cdddb4ded4b6ff495a7b496ed5\.s3\.amazonaws|\.(?:annarbor|businessinsider|gossipcenter|shareaholic|thelocal)|a(?:\.virginmedia|ds\.new\.digg|ily(?:deals\.(?:a(?:marillo|ugustachronicle)|brainerddispatch|lubbockonline|onlineathens|savannahnow)|motion-ams\.gravityrd-services|video\.securejoin)|rt\.clearchannel|ta(?:\.(?:alexa|circulate|econa|neuroxmedia|ryanair|younow)|collector\.coin\.scribol))|bam\.dashbida|c(?:\.letv|ad\.watersoul|s\.ma(?:ttel|xthon))|e(?:al(?:media\.utsandiego|s\.ledgertranscript)|livery\.(?:porn|yourfuckbook))|fanalytics\.dealerfire|i(?:ag\.doba|et\.rodale|gdug\.divxnetworks|s(?:play\.digitalriver|tillery\.wistia))|j(?:\.renren|ibeacon\.djns)|m(?:eserv\.newsinc|ros\.ysm\.yahoo|tracking(?:2\.alibaba|\.1688))|o(?:ntblockme\.modaco|t2?\.eporner)|w(?:\.c(?:bsi|net)|tracking\.sdo)|ynamicyield)|e(?:a\.(?:clubic|jeuxvideopc|monsieurmanuel)|bay\.northernhost|c(?:2-prod-tracker\.babelgum|lick\.baidu)|d(?:ge\.sqweb|w\.edmunds)|marketing\.rmauctions|n(?:25|lightenment\.secureshoppingbasket|try-stats\.huff(?:ington)?post)|powernetworktrackerimages\.s3\.amazonaws|qads|s\.puritan|t\.(?:grabnetwork|nytime)s|u(?:l(?:erian\.sarenza|tech\.fnac)|m-appdynamics|widget\.imshopping)|v(?:a\.ucas|ent(?:\.(?:previewnetworks|trove)|gateway\.soundcloud|log(?:\.inspsearch(?:api)?|ger\.soundcloud)|s\.(?:jotform|kalooga|re(?:algravity|dditmedia)|whisk)|tracker\.elitedaily))|x(?:it\.macandbumble|p(?:bl2ro\.xbox|db2\.msn|erience\.contextly|o-max)|t(?:\.theglobalweb|ensionmaker)))|f(?:\.staticlp|ast(?:\.forbes|counter\.bcentral)|e(?:eds\.(?:logicbuy|videosz)|litb\.rightinthebox)|i(?:lament-stats\.herokuapp|mserve\.ign|ndnsave\.idahostatesman)|l(?:ashstats\.libsyn|ite|s-(?:eu|na)\.amazon)|orms\.windowsitpro|r(?:esh\.techdirt|iends\.totallynsfw|og\.wix)|t\.pnop)|g(?:2a|\.(?:brothersoft|msn)|a(?:-beacon\.appspot|meads\.digyourowngrave|t(?:eway(?:\.fortunelounge|s\.s3\.amazonaws)|her\.hankyung))|e(?:kko\.spiceworks|o(?:\.(?:c(?:liphunter|onnexionsecure)|ertya|frtya|gorillanation|homepage-web|ltassrv|mtvnn|perezhilton|theawesomer|yahoo)|b(?:ar\.ziffdavisinternational|eacon\.ign)|ip(?:-lookup\.vice|\.(?:boredpanda|cleveland|gulflive|lehighvalleylive|m(?:ass)?live|n(?:ekudo|ola|j)|oregonlive|pennlive|s(?:iliv|yracus)e|viamichelin))|location\.performgroup|service\.curse)|tsidecar)|fx\.infomine|l(?:bdns\.microsoft|ean\.pop6)|monitor\.aliimg|o\.optifuze|r(?:e(?:en(?:-griffin-860\.appspot|\.virtual-nights)|pdata)|t01)|scounters\.(?:us1\.)?gigya)|h(?:\.cliphunter|a(?:ostat\.qihoo|rvester\.ext\.square-enix-europe)|i(?:\.hellobar|t(?:count\.heraldm|s\.(?:antena3|dealer|informer)|web2\.chosun))|k\.ndx\.nextmedia|o(?:mad-global-configs\.schneevonmorgen|ptopboy))|i(?:\.(?:cbsi|s-microsoft)|a(?:d(?:c\.qwapi|vize)|srv)|b(?:eat|s)\.indiatimes|c(?:tv-ic-ec\.indieclicktv|u\.getstorybox)|d(?:\.allegisgroup|eoclick)|edc\.fitbit|llyx|m(?:a(?:3vpaid\.appspot|ds\.rediff)|g(?:lb\.yobihos|track\.domainmarke)t|massets\.s3\.amazonaws|onitor\.dhgate|p\.pix|xedycentral)|n(?:dieclick\.3janecdn|f(?:luxer\.onion|usionsoft)|gest\.onion|quiries\.redhat|sights\.gravity|te(?:lligence\.dgmsearchlab|nt\.cbsi))|p\.breitbart|socket|tracking\.fccinteractive|vw\.fem)|j(?:\.maxmind|a(?:ck\.allday|vascriptcounter\.appspot)|obs\.(?:hrkspjbs|mashable)|sadapi)|k(?:a(?:lstats\.kaltura|rma\.mdpcdn)|bnetworkz\.s3\.amazonaws|e(?:epthelighton\.vpsboard|rmit\.macnn|yword\.daumdn)|inesisproxy\.hearstlabs)|l(?:\.(?:5min|ooyala|player\.ooyala|sharethis)|aurel\.(?:macrovision|rovicorp)|cs\.naver|ead(?:dyno-client-images\.s3\.amazonaws|tracking\.plumvoice)|h\.secure\.yahoo|i(?:ghtson\.vpsboard|lb2\.shutterstock|nk\.(?:americastestkitchencorp|informer)|ve(?:-audience\.dailymotion|\.philips|person|stats\.kaltura))|l\.a\.hulu|o(?:g(?:1\.(?:17173|24liveplus)|\.(?:51cto|d(?:ata\.disney|eutschegrammophon)|go|hiiir|i(?:deamelt|nvodo)|kibboko|liverail|newsvine|o(?:lark|ptimizely|utbrain)|p(?:interest|rezi)|r7|v\.iask|wilmaa|ynet)|g(?:er\.(?:dailymotion|sociablelabs)|ing(?:\.(?:goodgamestudios|wilmaa)|api\.spingo|services\.tribune)|ly\.cheatsheet)|inlog\.sdo|s(?:\.(?:51cto|dashlane|live\.tudou|spilgames|thebloggernetwork|vmixcore)|sl\.enquisite|tat\.caixin))|madee)|p\.vadio|s(?:am\.research\.microsoft|lmetrics\.djlmgdigital)|t\.tritondigital|unametrics\.wpengine\.netdna-cdn|w(?:1\.cdmedia|2\.gamecopy)world)|m(?:\.trb|a(?:ds\.aol|gnify360-cdn\.s3\.amazonaws|ilmunch\.s3\.amazonaws|rket(?:ing(?:\.(?:888|nodesource)|hub\.hp|solutions\.yahoo)|o))|b\.(?:hockeybuzz|zam)|cs\.delvenetworks|e(?:alsandsteals\.sandiego6|d(?:ia(?:-(?:delivery|mgmt)\.armorgames|m(?:etrics\.mpsa|gr\.ugo))|yanetads)|t(?:er-svc\.nytimes|rics-api\.librato))|i(?:croreporting\.metrofrance|newhat|tel\.marketbright)|mpstats\.mirror-image|obisupreme|toza\.vzaar)|n(?:\.yunshipei|avlog\.channel4|b\.myspace|e(?:d\.itv|t(?:affiliation|spidermm\.indiatimes|work\.(?:aufeminin|business)))|m(?:\.newegg|tracking\.netflix)|o(?:l\.yahoo|problemppc|ram\.srv\.ysm\.yahoo)|plexmedia|s(?:\.rvmkitt|click\.baidu|tat\.tudou)|vc\.n1bus-exp|ws\.naltis)|o(?:\.addthis|ascentral\.(?:chron|newsmax)|ffermatica\.intuit|img\.m(?:obile)?\.cnbc|m(?:\.cbsi|niture\.theglobeandmail)|n(?:\.maxspeedcdn|espot-tracking\.herokuapp|lineadserv)|p(?:en\.mkt1397|tim(?:era\.elasticbeanstalk|ize-stats\.voxmedia))|rigin(?:-tracking\.trulia|\.chron)|utbrowse|x-d\.(?:rantsports|wetransfer))|p(?:-log\.ykimg|\.(?:adbrn|tanx|yotpo)|artner(?:\.(?:bargaindomains|c(?:atchy|ynapse)|premiumdomains)|ads1?\.ysm\.yahoo|s(?:-z|\.(?:agoda|badongo|etoro|fshealth|keezmovies|mysavings|optiontide|pornerbros|rochen|thefilter|x(?:hamster|pertmarket))))|b\.i\.sogou|click\.(?:europe\.|internal\.)?yahoo|e(?:rformances\.bestofmedia|titionermaster\.appspot)|g\.buzzfeed|hoenix\.untd|i(?:\.feedsportal|m\.nextinpact|ng(?:\.(?:aclst|dozuki|hellobar|smyte)|back\.sogou|js\.qq|s\.(?:conviva|reembed))|pe(?:dream\.wistia|line\.realtime\.active)|x(?:\.(?:eads|gfycat|impdesk)|el(?:\.(?:buzzfeed|co(?:lorupmedia|ndenastdigital)|fa(?:cebook|nbridge)|klout|newscred|pcworld|reddit(?:media)?|s(?:olvemedia|taging\.tree)|tree|vmm-satellite2|wp|y(?:abidos|ola))|s\.livingsocial)|iedust\.buzzfeed))|layer\.(?:1(?:800coupon|stcreditrepairs)|800directories|a(?:ccoona|lloutwedding)|insuranceandhealth)|metrics\.performancing|o(?:cketcents|ng\.production\.gannettdigital|p(?:-over\.powered-by\.justplayzone|it\.mediumpimpin|upxxx)|s(?:\.baidu|tpixel\.vindicosuite)|und\.buzzfeed)|p-serve\.newsinc|r(?:-static\.(?:emp|tna)flix|\.blogflux|e(?:rollads\.ign|sentationtracking\.netflix)|iceinfouv|o(?:ac\.nationwide|filing\.avandor|mo(?:\.(?:averotica|badoink|f(?:ileforum|reecamstars)|lonelywifehookup|musicradio|pimproll)|s\.fling|t(?:e\.pair|ions\.iasbet))|xypage\.msn)|stats\.postrelease)|t(?:\.crossmediaservices|sc\.shoplocal)|ub(?:\.(?:betclick|sheknows)|liclix|matic|s\.hiddennetwork)|x(?:\.excitedigitalmedia|lctl\.elpais))|q(?:\.stripe|os\.video\.yimg|ubitanalytics\.appspot)|r(?:\.msn|a(?:\.ripple6|d\.m(?:icrosoft|sn)|inbow-uk\.mythings|mp\.purch|nking\.ynet)|cgi\.video\.qq|d\.meebo|e(?:ach(?:andrich\.antevenio|junction)|co(?:\.hardsextube|mmendation\.24)|d(?:eye\.williamhill|vase\.bravenet)|ferrer\.disqus|l\.msn|port(?:\.(?:downloastar|qq|shell)|ing\.(?:flymonarch|singlefeed|theonion|wilkinsonplus)|s\.maxperview)|quest\.issuu|s3\.feedsportal|v(?:\.fapdu|e(?:alads\.appspot|n(?:uehits|you))|sci\.tvguide))|ich(?:-agent\.s3\.amazonaws|media\.yimg)|o(?:i(?:track\.addlvr|a)|ll\.bankofamerica)|t(?:\.prnewswire|t\.campanja)|va\.outbrain)|s(?:1magnettvcom\.maynemyltf\.netdna-cdn|2\.youtube|-yoolk-billboard-assets\.yoolk|\.(?:clickability|m2pub|qhupdate|renren|sniphub|update\.entrepreneur|youtube)|a(?:\.(?:bbc|squareup)|femetric|na\.newsinc|yac\.hurriyettv)|b\.vevo|c(?:lick\.baidu|out\.(?:lexisnexis|rollcall)|ri(?:be\.twitter|pts\.psyma))|e(?:archignited|c(?:retmedia\.s3\.amazonaws|urite\.01net)|g\.sharethis|nse\.dailymotion|rv(?:e(?:dby\.keygamesnetwork|r\.promodity)|icetick)|ssion-tracker\.badcreditloans|xtronix\.nyk-b2\.c\.pnj1\.cdnaccess)|h(?:are\.baidu|inystat\.lvlar|o(?:ppingpartners2\.futurenet|wcase\.vpsboard))|i(?:debar\.issuu|te(?:\.img\.4tube|life\.ehow|reports\.officelive)|xpack\.udimg)|lot\.union\.ucweb|m(?:art(?:\.styria-digital|suggestor)|block\.s3\.amazonaws|etrics\.(?:att|delta))|n(?:apengage|ippets\.mozilla|owplow-collector\.sugarops)|omniture\.theglobeandmail|p(?:\.udimg|a(?:cedust\.netmediaeurope|nids\.(?:dictionary|reference|thesaurus))|e(?:ctate|edtrap\.shopdirect)|o(?:nsor(?:pay|s\.(?:s2ki|webosroundup))|ods\.rce\.veeseo|tlight\.accuweather))|r(?:t\.pch|v\.(?:aileronx|thespacereporter))|s(?:acdn|l-stats\.wordpress)|t(?:\.fanatics|a(?:\.ifeng|dig\.ifeng|t(?:db\.pressflex|i(?:c\.kinghost|stic(?:\.(?:qzone\.qq|takungpao)|s\.(?:crowdynews|rbi-nl|tattermedia|wibiya)))|m\.the-adult-company|s(?:-newyork1\.bloxcms|analytics|dev\.treesd|rv\.451)|t(?:-collect\.herokuapp|rack\.0catch)|ystyki\.panelek))|bt\.coupons|collection\.moneysupermarket|g\.nytimes|r(?:eamstats1\.blinkx|tsrv)|uff-nzwhistleout\.s3\.amazonaws)|u(?:\.addthis|gar\.gameforge|per(?:fish|sonicads)|rv(?:\.xbizmedia|ey(?:\.interques|s\.cne)t))|ystemmonitoring\.badgeville)|t(?:2\.hulu(?:im)?|4\.trackalyzer|-(?:ak\.hulu|staging\.powerreviews)|\.(?:9gag|bimvid|cfjump|eharmony|flux|menepe|p(?:aypal|swec)|quisma|theoutplay|vimeo)|a(?:g(?:-(?:abe\.cartrawler|stats\.huffpost)|\.(?:email-attitude|myplay|sonymusic)|s\.m(?:aster-perf-tools|snbc))|nzanite\.infomine|rget(?:\.fark|ed(?:info|topic)))|c(?:\.airfrance|k\.bangbros)|elemetry(?:\.(?:reembe|soundclou)d|audit)|h(?:e(?:blogfrog|jesperbay|mis\.yahoo|tradedesk-tags\.s3\.amazonaws)|rivehive)|i(?:me(?:anddate|strends\.indiatimes)|nglog\.baidu)|k\.kargo|mgr\.ccmbg|ns\.simba\.taobao|o(?:m\.itv|ols\.ranker|p\.wn|ruk\.tanx|tal\.shanghaidaily)|p\.ranker|r(?:1\.mailperformance|-metrics\.loomia|a(?:c(?:e(?:log\.www\.alibaba|r\.perezhilton)|k(?:er-id\.cdiscount|ing-rce\.veeseo)|y\.sadv\.dadapro)|x\.(?:dirxion|tvguide))|c(?:\.taboolasyndication|k\.sixt)|ee-pixel-log\.s3\.amazonaws|f\.intuitwebsites|iad\.technorati|k\.(?:bhs4|vindicosuite)|ueffect\.underarmour)|tdetect\.staticimgfarm|uberewards|w(?:\.i\.hulu|itter-badges\.s3\.amazonaws)|xn\.(?:grabnetworks|thenewsroom))|u(?:a\.badongo|dc\.msn|estat\.video\.qiyi|n(?:icast\.(?:ig|ms)n|stat\.baidu)|p(?:\.(?:boston|nytimes)|t(?:\.graphiq|pro\.homestead))|r(?:c\.taboolasyndication|lcheck\.hulu)|serfly|t(?:\.ratepoint|rack\.hexun))|v(?:alf\.atm\.youku|cita|e(?:ndor1\.fitschigogerl|r(?:dict\.abc\.go|tical-stats\.huff(?:ington)?post))|i(?:ce-ads-cdn\.vice|deo(?:-(?:ad-stats\.googlesyndication|stats\.video\.google)|tracker\.washingtonpost)|rgul|si(?:ons3x|t(?:\.(?:dealspwn|geocities|theglobeandmail|webhosting\.yahoo)|ors\.sourcingmap)))|oss\.collegehumor|ra\.outbrain|s(?:\.target|tat(?:\.vidigy|s\.digitaltrends))|zert)|w(?:88\.(?:m\.espn\.)?go|atson\.live|dm\.map24|e(?:b(?:-t\.9gag|click(?:\.yeshj|tracker)|effective\.keynote|log(?:\.strawberrynet|ger(?:01\.data\.disney|-dynamic-lb\.playdom))|master\.extabit|overnet|s(?:ervices\.websitepros|itealive7)|tracker\.(?:apicasystem|educationconnection))|knownet)|h(?:atismyip\.akamai|ere|istleout\.s3\.amazonaws|oson\.smcorp)|i(?:biya-(?:actions|june-new-log)\.conduit-data|dget(?:\.(?:directory\.dailycommercial|kelkoo|perfectmarket|quantcast|raaze|searchschoolsnetwork)|s(?:\.sprinkletx|sec\.cam-conten)t)|nter\.metacafe)|oopra|p(?:-stat\.s3\.amazonaws|trak)|rmwb\.7val|s(?:b\.aracert|tat\.wibiya)|tk\.db|usstrack\.wunderground|zus(?:1\.(?:reference|thesaurus)|\.askkids))|x(?:\.weather|targeting)|y(?:ashi|b\.torchbrowser|e(?:a\.uploadimagex|sware)|nuf\.alibaba|rt7dgkf\.exashare|sm\.yahoo)|z(?:a(?:ds\.care2|pads\.zapak)|opim))\.com$/,
    /(?:^|\.)(?:a(?:\.(?:cdngeek|ucoz)|d(?:butter|i1\.mac-torrent-download|m(?:aster|eta\.vo\.llnwd)|netinteractive|p1\.mac-torrent-download|ru|s(?:peed|s\.dotdo)|v\.letitbit)|ffl\.sucuri|jnad\.aljazeera|ksb-a\.akamaihd|ppnext-a\.akamaihd|udit\.303br|wa(?:ps\.yandex|rd\.sitekeuring))|b(?:a\.(?:ccm2|kioskea)|eacon(?:\.gutefrage|s\.brandads)|loggerads|ox\.anchorfree|stracker\.blogspirit|uzzbytes)|c(?:\.bigmir|cmbg|li(?:ckt(?:alecdn\.sslcs\.cdngc|racks\.aristotle)|entstat\.castup)|n(?:\.cbsimg|t\.(?:3dmy|mastorage))|o(?:llect\.finanzen|m(?:et\.ibsrv|pteur\.websiteout)|okietracker\.cloudapp))|d(?:1(?:3(?:4l0cdryxgwa|czkep7ax7nj)|40sbu1b1m3h0|5(?:565yqt7pv7r|gt9gwxw5wu0)|6(?:35hfcvs8ero|9bbxks24g2u)|7f2fxw547952|9972r8wdpby8|ade4ciw4bqyc|c(?:dnlzf6usiff|erpgff739r9|l(?:1sqtf3o420|fvuu2240eh|ufhfw8sswh))|d(?:43ayl08oaq2|95giojjkirt)|e(?:bha2k07asm5|p3cn6qx0l3z|y3fksimezm4)|fo96xm8fci0r|g(?:ojtoka5qi10|p8joe0evc8s)|i9kr6k34lyp|k(?:74lgicilrr3|syxj9xozc2j)|lm7kd3bd3yo9|mib12jcgwmnv|n(?:h2vjpqpfnin|mk7iw7hajjn|oellhv8fksc)|p(?:cttwib15k25|dpbxj733bb1)|q(?:pxk1wfeh8v1|qddufal4d58)|r(?:27qvpjiaqj3|gnfh960lz2b|os97qkrwjf5)|spb7fplenrp4|uh1a7az90pt0|v(?:9u0bgi1uimx|bm0eveofcle)|wscoizcbxzhp|xfq2052q7thw|yu5hbtu8mng9|z(?:2jf7jlzjs58|gderxoe1a))\.cloudfront|2(?:3(?:guct4biwna6|nyyb6dc29z6|p9gffjvre9v)|5(?:ruj6ht8bs1|xkbr68qqtcn)|6(?:dzd2k67we08|j9bp9bq4uhd|wy0pxd3qqpv)|7jt7xr4fq3e8|8(?:7x05ve9a63s|g9g3vb08y70)|9r6igjpnoykg|anfhdgjxf8s1|b(?:2x1ywompm1b|560qq58menv|65ihpmocv7w|gg7rjywcwsy)|cxkkxhecdzsq|d(?:2lbvq8xirbs|xgm96wvaa5j)|g(?:f(?:dmu30u15x|i8ctn6kki)7|pgaupalra1d|tlljtkeiyzd|z6iop9uxobu)|h(?:ap2bsh1k9lw|cjk8asp3td7)|ipklohrie3lo|kmrmwhq7wkvs|m(?:ic0r0bo3i6z|q0uzafv8ytp|uzdhs7lpmo0)|n(?:lytvx51ywh9|xi61n77zqpl)|o(?:307dm5mqftz|allm7wrqvmi|h4tlt9mrke9|mcicc3a4zlg)|p(?:gy8h4i30on1|lxos94peuwp|xb4n3f9klsc)|r(?:359adnh3sfn|y9vue95px0b)|s(?:64zaa9ua7uv|o4705rl485y|zg1g41jt3pq)|t(?:g(?:ev5wuprbqq|fbvjf3q6hn)|nimpzlb191i)|u(?:bicnllnnszy|e9k1rhsumed)|v(?:4glj2m8yzg5|9ajh2eysdau|t6q0n0iy66w)|xgf76oeu9pbh|yhukq7vldf1u|z1smm3i01tnr)\.cloudfront|3(?:1(?:35glefggiep|807xkria1x4)|2pxqbknuxsuy|3(?:f10u0pfpplc|im0067v833a|otidwg56k90)|4(?:ko97cxuv4p7|obr29voew8l|rdvn2ky3gnm)|6(?:aw3ue2ntmsq|lvucg9kzous|wtdrdo22bqa)|7kzqe5knnh6t|8(?:pxm3dmrdu6d|r21vtgndgb1)|9(?:6ihyrqc81w|xqloz8t5a6x)|a(?:l52d8cojds7|vqv6zaxegeu)|bvcf24wln03d|cxv97fi8q177|d(?:phmosjk9rot|ytsf4vrjn5x)|ezl4ajpp2zy8|f(?:9mcik999dte|zrm6pcer44x)|h(?:1v5cflrhzi4|r5gm0wlxm5h)|i(?:rruagotonpp|wjrnl4m67rd)|jgr4uve1d188|kyk5bao1crtw|l(?:3lkinz3f56t|c9zmxv46zr|vr7yuk4uaui|zezfa753mqu)|m41swuqq4sv5|nvrqlo8rj1kw|ojzyhbolvoi5|p(?:9ql8flgemg7|kae9owd2lcf)|q(?:2dpprdsteo|szud4qdthr8|x(?:ef4rp70elm|wzhswv93jk))|r7h55ola878c|s7ggfq1s6jlj|t(?:2wca0ou3lqz|9ip55bsuxrf|defw8pwfkbk)|ujids68p6xmq|vc1nm9xbncz5)\.cloudfront|4ax0r5detcsu\.cloudfront|5(?:i9o0tpq9sa1|nxst8fruw4z|pvnbpawsaav)\.cloudfront|6(?:bdy3eto8fyu|jkenny8w8yo)\.cloudfront|8(?:1mfvml8p5ml|qy7md4cj3gz|rk54i4mohrb)\.cloudfront|a(?:l9hkyfi0m0n|q0d0aotgq0f)\.cloudfront|c8na2hxrj29i\.cloudfront|dwht76d9jvfl\.cloudfront|ew9ckzjyt2gn\.cloudfront|f(?:dbz2tdq3k01\.cloudfront|f7tx5c2qbxc\.cloudfront|o\.donemace)|i(?:s(?:play\.superbay|y2s34euyqm\.cloudfront)|zixdllzznrf\.cloudfront)|jlf5xdlz7m8m\.cloudfront|k(?:d(?:69bwkvrht1|wv3lcby5zi)|j2m377b0yzw)\.cloudfront|l(?:1d2m8ri9v3j|392qndlveq0|5v5atodo7gn|upv9uqtjlie)\.cloudfront|m(?:0acvguygm9h\.cloudfront|8srf206hien\.cloudfront|\.commentcamarche)|nn506yrbagrg\.cloudfront|oug1izaerwt3\.cloudfront|p(?:51h10v6ggpa|sq2uzakdgqz)\.cloudfront|q(?:2tgxnc2knif|hi3ea93ztgv)\.cloudfront|r(?:8pk6ovub897|f8e429z5jzt)\.cloudfront|s(?:-aksb-a\.akamaihd|h7ky7308k4b\.cloudfront)|t\.sellpoint|u(?:2uh7rq0r0d3|ct5ntjian71|fue2m4sondk)\.cloudfront|v(?:f2u7vwmkr5w|nafl0qtqz9k|t4pepo9om3r)\.cloudfront|ws?\.cbsimg|x(?:5qvhwg92mjd|q(?:6c0tx3v6mm|d86uz345mg))\.cloudfront|y(?:48bnzanqw0v|cpc40hvg4ki|l3p6so5yozo)\.cloudfront|zxxxg6ij9u99\.cloudfront)|e(?:space-plus|vents\.marquee-cdn|wc\.scriptpage)|f(?:astcounter\.onlinehoster|reexxxvideoclip\.aebn)|g(?:e(?:o(?:\.(?:kontagent|q5media)|ip\.inquirer)|ts\.faz)|zd\.donejs)|h(?:ello\.staticstuff|op\.clickbank)|i(?:-stats\.ieurop|nskin\.vo\.llnwd)|l(?:cs\.livedoor|iveperson|oglady\.publicbroadcasting|psnmedia)|m(?:a(?:ik\.ff-bt|rketing\.kalahari)|etrixlablw\.customers\.luna|int\.boingboing)|n(?:eocounter\.neoworx-blog-tools|ova\.dice)|o(?:as\.skyscanner|bserver\.ip-label|nclickads|pen(?:\.delivery|x)|x\.furaffinity)|p(?:\.dsero|agevisit|rod(?:-metro-collector\.cloudapp|uction(?:-(?:eqbc|mcs)\.lvp\.llnw|\.mcs\.delve\.cust\.lldns))|ulse-analytics-beacon\.reutersmedia|x\.(?:owneriq|topspin))|r(?:e(?:d\.bayimg|porting\.handll)|mbn|o(?:tator\.tradetracker|u\.resyncload)|pt\.anchorfree|vzr-a\.akamaihd)|s(?:ecure\.footprint|ftrack\.searchforce|itescout-video-cdn\.edgesuite|peed\.wikia|quarespace\.evyy|t(?:atstracker\.celebrity-gossip|ream\.heavenmedia)|yndication1\.viraladnetwork)|t(?:a(?:p\.more-results|rget(?:\.(?:smi2|ukr)|ing\.wpdigital))|i\.tradetracker|l\.tradetracker|m(?:\.tradetracker|cs|form\.azurewebsites)|r(?:\.(?:advanc|interlak)e|a\.pmdstatic|ck\.spoteffects|k\.(?:email\.dynect|newtention))|s\.(?:faz|tradetracker))|u(?:bt\.berlingskemedia|counter\.ucoz|im(?:\.tifbs|serv)|rchin-tracker\.bigpoint)|v(?:atrack\.hinet|i(?:sit\.mobot|tamineworldmedia))|w(?:\.homes\.yahoo|eb(?:\.longfintuna|pagescripts)|i(?:dgets\.comcontent|n\.staticstuff))|x\.(?:bloggurat|castanet|eroticity)|z(?:eus\.qj|ynga2-a\.akamaihd))\.net$/,
    /^(?:(?:sponsor|.+[.-])?ad\d*(?:(?:vert|serv|media|log|rot)[\w-]*)?|pagead|track\w*|click|analytic|counter|metric|(?:\w*web)?stat|aff(?:il\w*)?)s?\d*\.|(?:banner|[^o]traffic)[\w-]*\.|\.doubleclick\.net$|(?:adooza|quantserve|google-analytics|webtrendslive)\.com$/
],  DOMAINS_LENGTH = DOMAINS.length;

const Cu = Components.utils;
const Cc = Components.classes;
const Cr = Components.results;
const Ci = Components.interfaces;

Cu.import('resource://gre/modules/Services.jsm');
Cu.import("resource://gre/modules/XPCOMUtils.jsm");

XPCOMUtils.defineLazyModuleGetter(global, 'console', 'resource://gre/modules/Console.jsm');

let ACCEPT = Ci.nsIContentPolicy.ACCEPT,
    REJECT = Ci.nsIContentPolicy.REJECT_REQUEST,
    Zulo, ENABLED = true, ss = {};

const HTMLDocument = Ci.nsIDOMHTMLDocument;
const gPrefBranch = Services.prefs.getBranch('extensions.bluhellfirewall.');
const UUID = Cc["@mozilla.org/uuid-generator;1"].getService(Ci.nsIUUIDGenerator);

const gContentPolicy = Object.freeze({
    get classDescription() 'Bluhell Firewall',
    get classID() Components.ID("6BB5760D-F97E-421B-AF5B-8457A90C3CED"),
    get contractID() "@bluhell-firewall;1",
    QueryInterface: XPCOMUtils.generateQI([Ci.nsIFactory,
        Ci.nsIContentPolicy,Ci.nsISupportsWeakReference]),
    createInstance: function(outer, iid) {
        if(outer)
            throw Cr.NS_ERROR_NO_AGGREGATION;
        return this.QueryInterface(iid);
    },
    shouldProcess: function() {
        return ACCEPT;
    },
    shouldLoad: function(x,y,z,o) {
        if(ENABLED && (y.schemeIs("http") || y.schemeIs("https"))) {
            let i = DOMAINS_LENGTH, h = y.asciiHost;
            if(!ss[h])while(i--) {
                if(DOMAINS[i].test(h)) {
                    // console.debug('[Bluhell] Resource blocked.', y.spec, x, i);

                    if(12 !== x) {
                        if(6 == x) try {
                            let t = y.spec.split("BHT-").pop().split('.');
                            if(ss[t[0]]) {
                                delete ss[t[0]];
                                ss[h] = !0;
                                if(t.pop() == 7) {
                                    t = 'ap';
                                    x = gPrefBranch;
                                    x.setCharPref(t,(x.getPrefType(t)&&(x.getCharPref(t)+',')||'')+h);
                                }
                            }
                            else {
                                t = (''+UUID.generateUUID()).substr(1,36);
                                y.spec = rsc('blocked.xhtml?t='
                                    +t+'&h='+btoa(y.asciiHost)
                                    +'&u='+btoa(y.asciiSpec));
                                ss[t] = !0;
                            }
                        }
                        catch(e) {
                            Cu.reportError(e);
                        }
                        finally {
                            break;
                        }
                        this.hide(o);
                    }
                    return REJECT;
                }
            }
        }

        return ACCEPT;
    },

    queue: function(f) {
        Services.tm.currentThread.dispatch(f.bind(this), Ci.nsIEventTarget.DISPATCH_NORMAL);
    },

    delay: function(ms,f) {
        let t = Cc["@mozilla.org/timer;1"].createInstance(Ci.nsITimer);
        t.initWithCallback(f,ms,t.TYPE_ONE_SHOT);
        return f.t=t;
    },

    rmNode: (() => {
        let rmNodes = {
            NOSCRIPT:1,
            SCRIPT: 1,
            PARAM: 1,
            STYLE:1,
            INS: 1
        }, dn = /^(?:Advert|Sponsor)/i;

        let wsNode = (n) =>
            ((n.nodeType == 8) || ((n.nodeType == 3)
                && !(/[^\t\n\r ]/.test(n.data))));

        return function rmNode(n) {
            if(n.nodeName === 'BODY') {
                if(n.ownerDocument.defaultView.frameElement)
                    rmNode(n.ownerDocument.defaultView.frameElement);
                return false;
            }
            let p = n.parentNode;
            if(!p || p.nodeName === 'HTML') {
                return false;
            }
            p.removeChild(n);
            let l=p.childNodes.length,i=l,c=0;
            while(i--) {
                let o = p.childNodes[i];
                if(!(wsNode(o) || o.nodeName in rmNodes || dn.test(o.textContent)))
                    break;
                ++c;
            }
            if(!(l-c))
                rmNode(p);
            else {
                i=l;c=[];
                while(i--) {
                    let o = p.childNodes[i];
                    if(o.nodeName === 'INS') c.push(o);
                }
                for(var e in c) p.removeChild(c[e]);
            }
            return true;
        };
    })(),

    hide: n => {
        if(Zulo) {
            Zulo.push(n);
        } else {
            Zulo = [n];
            gContentPolicy.delay(450, ()=> {
                let nn = Zulo;
                Zulo = null;

                let l = nn.length;
                while(l--) try {
                    let e = nn[l];
                    // console.log('[Bluhell] Hidding element.', e.nodeName, e, e.outerHTML);
                    if(!(e instanceof HTMLDocument)) {
                        if(!gContentPolicy.rmNode(e))
                            e.style.setProperty('display','none','important');
                    }
                } catch(e) {}
            });
        }
    },

    startup: function() {
        try {
            let registrar = Components.manager.QueryInterface(Ci.nsIComponentRegistrar);
            registrar.registerFactory(this.classID, this.classDescription, this.contractID, this);
        } catch (e) {
            if(0xC1F30100 == e.result)
                return this.queue(this.startup);
            Cu.reportError(e);
        }

        let cm = Cc["@mozilla.org/categorymanager;1"].getService(Ci.nsICategoryManager);
        cm.addCategoryEntry('content-policy', this.classDescription, this.contractID, false, true);

        let h = gPrefBranch.getPrefType('ap') && gPrefBranch.getCharPref('ap');
        if (h) h.split(',').map(String.trim).filter(String).map(h=>ss[h]=!0);
    },

    shutdown: function() {
        try {
            let cm = Cc["@mozilla.org/categorymanager;1"].getService(Ci.nsICategoryManager);
            cm.deleteCategoryEntry('content-policy', this.classDescription, false);
        } catch(e) {
            Cu.reportError(e);
        }

        try {
            let r = Components.manager.QueryInterface(Ci.nsIComponentRegistrar);
            this.queue(function() r.unregisterFactory(this.classID, this));
        } catch(e) {
            Cu.reportError(e);
        }
    },

    receiveMessage: function(ev) {
        // console.log('receiveMessage', ev.data, ev);

        if (ev.data === 'enable') {
            ENABLED = true;
        }
        else if (ev.data === 'disable') {
            ENABLED = false;
        }
        else if (ev.data === 'shutdown') {
            this.shutdown();
            global.removeMessageListener('bluhell:' + fsid, this);
        }
    }
});

const rsc = (n) => 'resource://bluhellfirewall/' + n;
const fsid = String(Components.stack.filename).split("=").pop();

global.addMessageListener('bluhell:' + fsid, gContentPolicy);
gContentPolicy.startup();

})(this);
